# DAN - Data Associative Net library.
# -----------------------------------
#  http://www.wtg.ru/
#  http://www.wtg.ru/products/dan
# -----------------------------------
#  E-mail:  zebra@wtg.ru
#           support@wtg.ru
#  Fidonet: 2:5049/138
# -----------------------------------
# Copyright (C) XXI White Tiger Group

package DAN;

sub BEGIN
 {

	require 5.001;
 #	use Exporter;
	use DB_File;
	use Fcntl ':flock';
 	use strict;
	use Carp;
	use vars qw($VERSION $BASE $FLOCK %dan $COPYRIGHT $DOSCOPYRIGHT $DEBUG $LANGTAKEDEFAULT $TRANSACTIONS);
	$VERSION='0.51';
	$COPYRIGHT=qq|&copy; XXI, <a href="http://www.wtg.ru/">WTG</a>|;
	$DOSCOPYRIGHT=qq|(C) XXI, White Tiger Group|;

 #   . -   
 # 0xXXXXXXXX,  X -  .  
 # 0xFFFFFFFF      
 #  4_294_967_295 ( ,   
 #    ,       
 # -  ).  , ,  
 #          
 # .     
 #  $DAN::BASE.
 #       
 #  sprintf.
	$BASE='0x%08X';

 # ,      
 #          
 #   (  )    ( ). 
 #      Windows9x,    
 #   flock.    Unix/Linux  WindowsNT/2000/XP
 #     .
 #      $DAN::FLOCK.  1
 #   "", 0 - "".
	$FLOCK=1;

 # ,      . 
 #         :
 #  ,    ,  .
 #      .
 #   ,  :  , 
 # .
 #     ,  
 # DAN     .
 #      $DAN::LANGTAKEDEFAULT.
 #  1   "", 0 - "".
	$LANGTAKEDEFAULT=0;

 # ,    ,     
 #      dan_io
	$DEBUG=0;
	if($DEBUG){open A,'>dan_io';my$i=localtime;print A "$i\nCalled by: $0\n\n"}

 # ,    . !  
 #         
	$TRANSACTIONS=0;

 }

sub new
 {
	shift;

	my($dan,@a,$a,$b,$c,$d,$j,$i);
	my$model=shift;
	my$base=shift;
	my$bodybase=shift;
	my$mode=shift;

	if($base && ($base eq $bodybase)){croak "DAN error: index and pages databases must be different";return}

	if($mode)
	{
		unless(-e$base){croak "DAN error: not found dataindex file"}
		if($bodybase && !(-e$bodybase)){croak "DAN error: not found database file"}
	}

	$dan->{_index_id}=$base;
	if($bodybase){$dan->{_body_id}=$bodybase}

 #   ,       
	$mode?_openv_r($dan,$dan->{_index_id},'index'):_openv($dan,$dan->{_index_id},'index');
	if($bodybase){$mode?_openv_r($dan,$dan->{_body_id},'body'):_openv($dan,$dan->{_body_id},'body')}



	$dan->{model}=$model;

	unless($dan->{baseversion}=_getv('x_dan',$dan->{baseindex},$dan))
	{
		unless($mode){$dan->Switch2RW}
		_putv('x_dan',$DAN::VERSION,$dan->{baseindex},$dan);
		_putv('x_dan',$DAN::VERSION,$dan->{basebody},$dan);
		unless($mode){$dan->Switch2RO}
	}

	@a=split(/\x00/,_getv("x_info_$dan->{model}",$dan->{baseindex},$dan));
	$dan->{createdate}=$a[0];
	$dan->{description}=$a[1];
	$dan->{modifydate}=$a[2];
	$dan->{danname}=$a[3];

	%{$dan->{type}}=split(/\x00/,_getv("x_type_$dan->{model}",$dan->{baseindex},$dan));
 # typename -    
	for(keys%{$dan->{type}}){$dan->{typename}->{$dan->{type}->{$_}}=$_}
 # typealias -  
	%{$dan->{typealias}}=split(/\x00/,_getv("x_typealias_$dan->{model}",$dan->{baseindex},$dan));
 # typerest -  : 0 - , 1 - , 2 -  
	%{$dan->{typerest}}=split(/\x00/,_getv("x_typerest_$dan->{model}",$dan->{baseindex},$dan));
 # counter -  
	%{$dan->{counter}}=split(/\x00/,_getv("x_counter_$dan->{model}",$dan->{baseindex},$dan));
 # rolealias -  
	%{$dan->{rolealias}}=split(/\x00/,_getv("x_rolealias_$dan->{model}",$dan->{baseindex},$dan));
 # rolename -  
	%{$dan->{rolename}}=split(/\x00/,_getv("x_rolename_$dan->{model}",$dan->{baseindex},$dan));
 # rolevector -  
	%{$dan->{rolevector}}=split(/\x00/,_getv("x_rolevector_$dan->{model}",$dan->{baseindex},$dan));
 # rolecorr -  
	%{$dan->{rolecorr}}=split(/\x00/,_getv("x_rolecorr_$dan->{model}",$dan->{baseindex},$dan));
 # rolerest -  
	%{$dan->{rolerest}}=split(/\x00/,_getv("x_rolerest_$dan->{model}",$dan->{baseindex},$dan));
 # languages -  
	($dan->{defaultlanguage},$a,@{$dan->{languages}})=split(/\x00/,_getv("x_languages_$dan->{model}",$dan->{baseindex},$dan));
 # influence -    
	%{$dan->{influence}}=split(/\x01/,$a);

 #   
	@a=split(/\x00/,_getv("x_model_$dan->{model}",$dan->{baseindex},$dan));

	for$i(@a)
	{
		my($type,@b)=split(/\x01/,$i);
		for$j(@b)
		{
			my($link,%a)=split(/\x02/,$j);
			%{$dan->{role}->{$type}->{$link}}=%a;
 # 
			for(keys%a)
			{
				@{$dan->{typerole}->{$_}}=($type,$link);
				$dan->{roleid}->{$dan->{rolevector}->{$_}}=$_
			}
		}
	}

	if($dan->{defaultlanguage}){push@{$dan->{currentlanguage}},$dan->{defaultlanguage}.'$'}
	push@{$dan->{currentlanguage}},'';

	return bless $dan;
 }


sub BaseVersion
 {
	my$dan=shift;return$dan->{baseversion}
 }

sub Cache
 {
	my$dan=shift;
	my$cache=shift;

	$dan->{cacheenabled}=$cache;if($DEBUG){print A "CACHE ".($cache?'ON':'OFF')."\n"}
	if(!$cache && (%{$dan->{cache}} || %{$dan->{cachebody}}))
	{
		my@a=keys%{$dan->{cache}};
		if(@a)
		{
			$dan->Switch2RW(1);
			for(@a)
			{
				if($dan->{cache}->{$_})
				{
					$dan->{baseindex}->put($_,$dan->{cache}->{$_});
					if($DEBUG){print A "cache_save_$dan->{_base_index}: $_ {",length$dan->{cache}->{$_},"}\n"}
				}
				else
				{
					$dan->{baseindex}->del($_);
					if($DEBUG){print A "cache_del_$dan->{_base_index}: $_\n"}
				}
			}
			$dan->Switch2RO(1);
			undef%{$dan->{cache}};
		}

		my@a=keys%{$dan->{cachebody}};
		if(@a)
		{
			$dan->Switch2RW(2);
			for(@a)
			{
				if($dan->{cachebody}->{$_})
				{
					$dan->{basebody}->put($_,$dan->{cachebody}->{$_});
					if($DEBUG){print A "cache_save_body_$dan->{_base_index}: $_ {",length$dan->{cachebody}->{$_},"}\n"}
				}
				else
				{
					$dan->{basebody}->del($_);
					if($DEBUG){print A "cache_del_body_$dan->{_base_index}: $_\n"}
				}
			}
			$dan->Switch2RO(2);
			undef%{$dan->{cachebody}};
		}
		if($DEBUG){print A "RESET CACHE\n"}
	}

	return
 }

 ## Compact -       
 # $deleted=Compact()
 #	:
 #	-  oi,    on
 #	-  on,    oi
 #	- ,   
 #	- ,    ( )
 #	-   (  )
 #      
 #   Compact,     
 #      ,   
 #   ;     
 # .
sub Compact
 {
	my$dan=shift;
	my$full=shift;
	my($i,$deleted);

	$dan->Cache;
	{
		$dan->{baseindex_tmp}=_openv($dan,$dan->{_index_id}.'_tmp','index_tmp');

		my($key,$rc,$val,$val1);
		for(	$rc=${$dan}{baseindex}->seq($key,$val,R_FIRST);
			$rc==0;
			$rc=${$dan}{baseindex}->seq($key,$val,R_NEXT)
		)
		{
			my$not;
			if($key=~/^oi_(\w\w\$)?(\d+):(.*)$/)
			{	my$a=$1;my$c=$2;my$b=$3;
				_putv("on_$a$c:$val",$b,$dan->{baseindex_tmp},$dan);
			}
			elsif($key=~/^on_(\w\w\$)?(\d+):(.*)$/)
			{
				my$a=$1;my$c=$2;my$b=$3;
				_putv("oi_$a$c:$val",$b,$dan->{baseindex_tmp},$dan);
			}
			elsif($key=~/^(\d+):(.*)_.*$/)
			{

			}
			elsif($key=~/^(\d+):(.*)$/)
			{
 #				my$a=$1;my$b=$2;
 #				my$val1;${$dan}{baseindex}->get("on_$a:$b",$val1);
 #				if($val1){++$not}
 #				my$val1;${$dan}{baseindex}->get("oi_$a:$val",$val1);
 #				if($val1){++$not}
 #				if($not<2){$not=1}
			}
			elsif($key!~/^[x_]_/){$not=1}

			if($not==1){++$deleted}
			else{_putv($key,$val,$dan->{baseindex_tmp},$dan)}
		}

 #    ,   
		for$i($dan->Types)
		{
			my@roles=$dan->Roles($i);
			for$j(@{$dan->TypeList($i)})
			{
				my%a;
				for$k(@{_listvalue("${j}_",$dan->{baseindex},0,"${j}_",R_NEXT)})
				{
					$k=~s/^${j}_//;
					my%b=split(/\x00/,_getv("${j}_$k",$dan->{baseindex},$dan));

					for$l(keys%b)
					{
						my$correct;
						my%c=split(/\x00/,_getv("${l}_".$dan->RoleCorr($k),$dan->{baseindex},$dan));
						unless($c{$j})
						{
							delete$b{$l};
							++$deleted;
						}
						else{$a{$k}=1}
					}
					if($a{$k}){_putv("${j}_$k",join(chr(0),%b),$dan->{baseindex_tmp},$dan)}
				}
				if(%a){_putv($j,join(chr(0),%a),$dan->{baseindex_tmp},$dan)}
			}
		}
		_putv('__propertylast',_getv('__propertylast',$dan->{baseindex},$dan),$dan->{baseindex_tmp},$dan);
		_closev($dan,'index_tmp');
		_closev($dan,'index');
		rename $dan->{_index_id}.'_tmp',$dan->{_index_id};
		$dan->{baseindex}=_openv_r($dan,$dan->{_index_id},'index');

	}

	for$i($dan->Types)
	{

		for(@{$dan->TypeList($i)})
		{
			if($dan->VerifyProperty($_)){++$deleted}
		}

		my@a=split(/\x01/,$dan->{counter}->{$i});
		$a[0]=scalar@{$dan->TypeList($i)};
		$dan->{counter}->{$i}=join(chr(1),@a);
	}
	$dan->Switch2RW;
	_putv("x_counter_forum",join(chr(0),%{$dan->{counter}}),$dan->{baseindex},$dan);
	$dan->Switch2RO;

	return$deleted
 }

sub CreateDate
 {
	my$dan=shift;
	my$a=shift;
	if($a){$dan->{createdate}=$a}
	return$dan->{createdate}
 }

 ## DeleteLink -    
 # DeleteLink(doi1,doi2,role [,mode])
 #    role   doi1  doi2.
sub DeleteLink
 {
	my$dan=shift;
	my($doi1,$doi2,$role12)=@_;
	my(%a,%b,$role21,$roles,$a);

	$role21=$dan->{rolecorr}->{$role12};
	if(!$doi1||!$doi2||!$role12||!$role21){return}

	_deletelink($dan,$doi1,$doi2,$role12);
	_deletelink($dan,$doi2,$doi1,$role21);

	return 1;
 }

 ## DeleteObject -  
 # $idtype=DeleteObject(doi)
 # @deletedobjects=DeleteObject(doi)
 #     .  ,    ,
 #    ,   .
sub DeleteObject
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my($dti,@a,$i);
	($dti,$doi)=split(/:/,$doi);
	$doi||=shift;
	unless($doi){return}
	$doi="$dti:$doi";
	my$wa=wantarray;

	my$links=$dan->PropertyLinksStructure($doi);
	unless($links){unless($dan->PropertyName($doi)){return}}


	push@a,$doi;
	for$i(keys%{$links})
	{
		for(keys%{$links->{$i}})
		{
			$dan->DeleteLink($doi,$_,$i);
			unless(@{$dan->PropertyLinks($_)})
			{
				$dan->DeleteProperty($_);
				/^(\d+)/;
				$dan->PropertyCounter($1,-1);
				if($wa){push@a,$_}
			}
		}
	}
	$dan->DeleteProperty($doi);
	$dan->PropertyCounter($dti,-1);

	if($wa){return@a}
	else{return $dti}
 }

 ## DeleteProperty -  
 # rez=DeleteProperty(doi)
 #    ,    .
sub DeleteProperty
 {
	my$dan=shift;
	my$doi=shift;
	my($a,$b,$i,$dti,$don,@a);

	($dti,$don)=split(/:/,$doi);

	unless($b=$dan->PropertyName($doi)){return 0}

	$a=$dan->PropertyLinksStructure($doi);

	for$i(keys%{$a})
	{
		for(keys%{$a->{$i}})
		{
			$dan->DeleteLink($doi,$_,$i)
		}
	}
	_delv($doi,$dan->{baseindex},$dan);

	for(@{$dan->{languages}},'')
	{
		if($_){$_.='$'}
		my$b=_getv("on_${_}$doi",$dan->{baseindex},$dan);
		_delv("on_${_}$doi",$dan->{baseindex},$dan);
		_delv("oi_${_}$dti:$b",$dan->{baseindex},$dan);
		if($dan->{basebody}){_delv("${_}$doi",$dan->{basebody},$dan)}
	}

	return $dti;
 }

 ## DeleteRole -   (    )
 # DeleteRole($role)
sub DeleteRole
 {
	my$dan=shift;
	my$role12=shift;
	my$dti1=$dan->RoleType($role12);
	my$dti2=$dan->RoleTypeBack($role12);
	my$role21=$dan->{rolecorr}->{$role12};
	my$rolename12=$dan->{rolevector}->{$role12};
	my$rolename21=$dan->{rolevector}->{$role21};

	delete$dan->{role}->{$dti1}->{$dti2}->{$role21};
	delete$dan->{role}->{$dti2}->{$dti1}->{$role12};
	delete$dan->{typerole}->{$role12};
	delete$dan->{typerole}->{$role21};
	delete$dan->{rolename}->{$role12};
	delete$dan->{rolename}->{$role21};
	delete$dan->{rolealias}->{$role12};
	delete$dan->{rolealias}->{$role21};
	delete$dan->{rolevector}->{$role12};
	delete$dan->{rolevector}->{$role21};
	delete$dan->{rolecorr}->{$role12};
	delete$dan->{rolecorr}->{$role21};
	delete$dan->{rolerest}->{$role12};
	delete$dan->{rolerest}->{$role21};
	delete$dan->{roleid}->{$rolename12};
	delete$dan->{roleid}->{$rolename21};

	return ''
 }

sub Description
 {
	my$dan=shift;
	my$a=shift;
	if($a){$dan->{description}=$a}
	return$dan->{description}
 }

 ## Exists -    
 # doi=Exists(dti,name,body,\%links)
 #      ,  
 #    \%links     ;
 #   \%links     
 # ,    .
sub Exists
 {
	my$dan=shift;
	my$dti=shift;
	my$name=shift;
	my$body=shift;
	my$links=shift;
	my(@a,$doi2,$doi,$body2,$links2,$false,$i,$a);

	$name=~s/\x01\d+$//;
	$a=$dan->PropertyList($dti,$name,0,$name);
	for(@{$a})
	{
		$false=0;
		$doi2=_getv($_,$dan->{baseindex},$dan);

		s/\x01\d+$//;s/^oi_(\.\.\$)?\d+://;
		if($name eq $_)
		{
			if($dan->{typerest}->{$dti} || (!$body && !$links)){return"$dti:$doi2"}
			if(!$body||($body&&($body eq $dan->PropertyBody("$dti:$doi2"))))
			{
				$links2=$dan->PropertyLinksStructure("$dti:$doi2");
 A1:				for$i(keys%{$links})
				{
					for(keys%{$links->{$i}})
					{
						if($links->{$i}->{$_}&&!$links2->{$i}->{$_}){$false=1;last A1}
					}
				}
				unless($false){return"$dti:$doi2"}
			}
		}
	}
	return'';
 }

 #      
sub Export
 {
	my$dan=shift;
	my$file=shift;
	my@a=@_;
	my($i,%i,$rc,$j,$key,$val,$cnt,$mode);


	my$begin=time;
	if($a[0]=~/^\d+:/){$mode=1}	# 
	elsif($a[0]){$mode=2}		#  

	unless(open TMP,">$file"){croak "DAN export error: unable to create file '$file' ($!)";return}
	my$i=localtime;
	print TMP qq|.dan\n\n[DAN]\nVersion=$VERSION\nBase=$BASE\nDate=$i\nCreated=$dan->{createdate}\nName=$dan->{danname}\nDescription=$dan->{description}\nLanguages=$dan->{defaultlanguage} @{$dan->{languages}}\n\n[MODEL]\n|;


 #  
	for$i(sort{$::a cmp $::b}keys%{$dan->{typename}})
	{
		if($mode==2)
		{	my$en;
			for(@a){if($i eq $_){$en=1;last}}
			unless($en){next}
		}
		$dan->{exported_types}->{$dan->TypeId($i)}=1;
		my$a=$dan->{typealias}->{$dan->{typename}->{$i}};
		print TMP "Type=$i,",$dan->{typerest}->{$dan->{typename}->{$i}}*1,",",$dan->{influence}->{$dan->{typename}->{$i}}*1,",",_codec_qp(\$a),"\n";
	}


	for$i(sort{$::a cmp $::b}keys%{$dan->{rolename}})
	{
		if($mode==2)
		{	my($en,$j);
			for$j(@a)
			{
				if($dan->TypeName($dan->RoleType($i)) eq $j)
				{
					for(@a)
					{
						if($dan->TypeName($dan->RoleTypeBack($i)) eq $_){$en=1;last}
					}
				}
				last if $en
			}
			unless($en){next}
		}
		$dan->{exported_roles}->{$i}=1;
		my$a=$dan->{rolealias}->{$i};
		print TMP "Role=$dan->{rolevector}->{$i},",$dan->{rolerest}->{$i}*1,",",_codec_qp(\$a),"\n";
	}

	my%a;
	for($dan->{defaultlanguage},@{$dan->{languages}},'')
	{	++$a{$_}
	}
	my@langs=sort keys%a;

 #  
	for$i(sort{$::a <=> $::b}keys%{$dan->{type}})
	{
		unless($dan->{exported_types}->{$i}){next}
		my@roles=$dan->Roles($i);
		$key="$i:";my$filter="^$i:";if($mode==1){$key=$a[0]}
		for($rc=${$dan}{baseindex}->seq($key,$val,R_CURSOR);
		$rc==0 && $key=~/$filter/;
		$rc=${$dan}{baseindex}->seq($key,$val,R_NEXT))
		{
			if($key=~/^$i:[\w\d]+_/){next}
			if($mode==1&&$a[1]&&$key gt $a[1]){last}
			my@p;my$en;my$name;my@b;my@n;

			for(@langs)
			{
				my$a=_getv("on_".($_?"$_\$":'').$key,$dan->{baseindex},$dan);
				if($a){push@n,"Name_$_=$a"}

				my$body=_getv(($_?"$_\$":'').$key,$dan->{basebody},$dan);
				if($body)
				{
					push@b,"Body_$_="._codec_qp(\$body);
					push@b,"CRC_$_=".sprintf('%08X',_crc32($dan,\$body));
				}
			}

			my$fullkey=$key;
			$key=~s/^(\d+)://;
			if($key)
			{
				push@p,"[ID:$key]","Type=$dan->{type}->{$i}",@n,@b;
				for$j(@roles)
				{
					unless($dan->{exported_roles}->{$j}){next}
					unless($dan->{rolevector}->{$j}){next}
					my@a;
					my%a=split(/\x00/,_getv("${fullkey}_$j",$dan->{baseindex},$dan));

					for(keys%a)
					{	if(s/^(\d+)://)
						{
							push@a,"$_=".$a{"$1:$_"}
						}
					}
				
					if(@a){$en=1;push@p,"Role=$dan->{rolevector}->{$j}, ".join(', ',@a)}
				}
				if($en){print TMP join("\n",'',@p,'');++$cnt}
			}
		}
	}

	print TMP "\n[INFO]\nProcess time=",time-$begin,"\n\n.end";

	unless(close TMP){croak "DAN export error: unable to completing export ($!)";return}
	return$cnt
 }


 ## FindId -         
sub FindId
 {
	my$dan=shift;
	my$dti=shift;
	my$name=shift;
	my($a,$b);

	if(!$dti || !$name){return}
	for($dan->Languages(),'')
	{
		$_&&=$_.='$';
		if($a=_getv("oi_${_}$dti:$name",$dan->{baseindex},$dan)){$b=$_;last}
	}
	if($a){return($a,$b)}else{return}
 }


 ## GetLanguage -   
 # $lang=GetLanguage()
 #     .
sub GetLanguage
 {
	my$dan=shift;
	my$a=${$dan->{currentlanguage}}[0];
	$a=~s/\$$//;
	return$a
 }


 ## GetObjectId -      
 # $doi=GetObjectId($dti,$name,\%links)
 # links -   
sub GetObjectId
 {
	my$dan=shift;
	my$dti=shift;
	my$name=shift;
	my($pro,$a,%prop)=@_;
	my($props,$doi,$i,$j);

	($dti)=split(/:/,$dti);
	unless($dti=~/^\d+$/)
	{	$dti=$dan->TypeId($dti);
		unless($dti){return}
	}
	elsif(!$dan->TypeName($dti)){return}

 #      
	unless(ref$pro eq 'HASH')
	{	
		$prop{$pro}=$a;
		$props=\%prop;
	}
 #    
	else{$props=$pro}
	for(keys%{$props})
	{
		unless($props->{$_}){delete$props->{$_};next}
		unless(/^\d+$/)
		{
			unless($dan->RoleId($_)){$!="Role vector '$_' incorrect.";return}
			$props->{$dan->{rolecorr}->{$dan->RoleId($_)}}=$props->{$_};
			delete$props->{$_};
			$_=$dan->{rolecorr}->{$dan->RoleId($_)}
		}
		if(ref($props->{$_}) eq 'HASH')
		{
			my@a;
			for$j(keys%{$props->{$_}})
			{
				push@a,\$j
			}
			$props->{$_}=\@a;

		}
		elsif(ref($props->{$_}) ne 'ARRAY')
		{
			my$a;
			$a=$props->{$_};
			delete$props->{$_};
			push@{$props->{$_}},$a;
		}
	}
 #   
	for$i(keys%{$props})
	{
		my$links;
		my$type=$dan->RoleTypeBack($i);
		for(@{$props->{$i}})
		{
			unless($_){next}
 #  -      
 #			if($dan->{role}->{$dti}->{$dan->RoleType($i)}->{$i})
			{
 #     
				if(ref$_ eq 'SCALAR'){$_=$$_}
 #     
				$dan->PropertyName($_)||return;
				$_||return
			}
		}
	}

	my$list=$dan->TypeList($dti,$name);
	for$i(@{$list})
	{
		my$failed=0;
		my$links=$dan->PropertyLinksStructure($i);
 A1:		for$j(keys%{$links})
		{
			for(@{$props->{$j}})
			{
				unless($links->{$j}->{$_}){$failed=1;last A1}
			}
		}
		if($failed){undef$failed}else{$doi=$i;last}
	}

	return $doi;
 }


 ## GetObject -   
 # (name,body,\%links)=GetObject(doi)
sub GetObject
 {
	my$dan=shift;
	my$doi=shift;
	my($props,$i);

	my($dti,$don)=split(/:/,$doi);
	$don||=shift;
	unless($don){return}

	unless($dti=~/^\d+$/)
	{	$dti=$dan->TypeId($dti);
		unless($dti){return}
		$doi="$dti:$don"
	}
	elsif(!$dan->TypeName($dti)){return}

	my$name=$dan->PropertyName($doi);
	my$body=$dan->PropertyBody($doi);
 #    
	if(my$links=$dan->PropertyLinks($doi))
	{	for$i(@{$links})
		{
			$props->{$i}=$dan->PropertyLinksProperty($doi,$i);
		}
	}
	return $name,$body,$props;
 }


 ## Import -    
 # (properties,links)=Import(file)
 #      
 # properties -   
 # links -     
sub Import
 {
	my$dan=shift;
	my$import=shift;
	my($mode,%a,$current,$a,$b,%str,$type,$links,$setted,$props);

	unless(-e$import){croak "DAN error: file '$import' not found";return}
	my$lang=$dan->GetLanguage();

	$dan->Cache;
	open TMP,$import;
	$a=<TMP>;
	unless($a=~/^\.dan/){croak "DAN error: file '$import' is not DAN import file";return}
	while(<TMP>)
	{
		chomp;
		if(/^\[DAN\]/){$mode='header';next}
		elsif($mode eq 'header')
		{

			unless(length){undef$mode;next}
			elsif(($a)=/^Created=(.*)/)	#   (  )
			{
				unless($dan->CreateDate()){$dan->CreateDate($a)}
			}
			elsif(($a)=/^Name=(.*)/)	#  
			{
				unless($dan->ModelName()){$dan->ModelName($a)}
			}
			elsif(($a)=/^Description=(.*)/)	#  
			{
				unless($dan->Description()){$dan->Description($a)}
			}
			elsif(($a)=/^Base=(.*)/)	#   
			{
				if($a ne $DAN::BASE){croak "DAN error: unable import '$import' that bases is different ($a vs. $DAN::BASE)";return}
			}
			elsif(($a)=/^Languages=(.*)/)	#  
			{
				my%a;
				for($dan->{defaultlanguage},@{$dan->{languages}},split(/\s+/,$a))
				{				
					++$a{$_};
				}
				$dan->Languages($dan->{defaultlanguage},keys%a);
			}
		}
		elsif(/^\[MODEL\]/){$mode='model';next}
		elsif($mode eq 'model')
		{
			unless(length){$dan->SaveModel();undef$mode;next}
			elsif(/^Type=(.*?)[,\s]+(\d+)[,\s]+(\d+)[,\s]+(.*)/)	#  
			{
				my@a=($1,$2,$3,$4);
				$str->{type}->{$a[0]}=$dan->TypeId($a[0]);
				unless($str->{type}->{$a[0]})
				{	$str->{type}->{$a[0]}=$a=$dan->SetType($a[0]);
					$dan->TypeRest($a,$a[1]);
					$dan->{influence}->{$a}=$a[2];
					$dan->TypeAlias($a,_codec_qp(\$a[3],1));
				}
			}
			elsif(/^Role=(.*?)[,\s]+(\d+)[,\s]+(.*)/)	#  
			{
				my@a=($1,$2,$3);
				my@b=split(/\./,$a[0]);
				$str->{role}->{$a[0]}=$a=$dan->SetRole($str->{type}->{$b[0]},$str->{type}->{$b[2]},$b[1],$b[3]);
				$dan->RoleRest($a,$a[1]);
				$dan->RoleAlias($a,_codec_qp(\$a[2],1));
			}
		}
		elsif(/^\[INFO\]/ || /^\.end/){last}
		elsif(/^\[ID:(.*)\]/){$mode='element';$current=$1}
		elsif($mode eq 'element')
		{
			if(($a)=/^Type=(.*)/)	# 
			{
				$type=$a;
				unless($str->{type}->{$type}){undef$mode;undef$type;undef$current;next}
			}
			elsif(($b)=/^Name_=(.*)/)	# 
			{
				unless($b){undef$mode;undef$type;undef$current;next}
				$dan->SetLanguage('',1);
				$str->{id}->{$current}=$dan->SetProperty($str->{type}->{$type},$b);
				++$props;
			}
			elsif(!$str->{id}->{$current})	#   
			{
				undef$mode;undef$type;undef$current;
			}
			elsif(($a,$b)=/^Name_(\w\w)=(.*)/)	#  
			{
				$dan->SetLanguage($a,1);
				$dan->SetProperty($str->{id}->{$current},$b)
			}
			elsif(($b)=/^Body_=(.*)/)	# 
			{
				$dan->SetLanguage('',1);
				$dan->PropertyBody($str->{id}->{$current},_codec_qp(\$b,1))
			}
			elsif(($a,$b)=/^Body_(\w\w)=(.*)/)	#  
			{
				$dan->SetLanguage($a,1);
				$dan->PropertyBody($str->{id}->{$current},_codec_qp(\$b,1))
			}
			elsif(($a,$b)=/^Role=(.+?)[,\s]+(.*)/)	# 
			{
				my@b=split(/[\s,]+/,$b);

				@{$str->{links}->{$current}->{$a}}=@b;
				$links+=scalar@b;
			}
			elsif(!length)
			{
				undef$mode;
				undef$type;
				undef$current;
			}
		}
	}
	unless(close TMP){croak "DAN export error: unable to completing export ($!)";return}
	$dan->SetLanguage($lang);

	if($links)	#  
	{
		for$i(keys%{$str->{id}})	# 
		{
			unless($i){next}my($value);
			$fromlink=$str->{id}->{$i};
			for$j(keys%{$str->{links}->{$i}})	#  
			{
				unless($j){next}
				for$tolink(@{$str->{links}->{$i}->{$j}})	# 
				{
					($tolink,$value)=split(/=/,$tolink);

					unless($tolink=$str->{id}->{$tolink}){next}

					_addlink($dan,$fromlink,$tolink,$str->{role}->{$j},$value);
					++$setted

				}
			}
		}
	}

	return($props,$setted)
 }


 ## Influence - /  
 # @inf=Influence()
 #   ,   
 #   .
 # 
 # @oldinf=Influence(@newinf)
 #  ,    
 #  .  @newinf -  
 # .
 #   .
sub Influence
 {
	my$dan=shift;
	my@inf=@_;

	my@a=keys%{$dan->{influence}};
	if(@inf)
	{
		undef%{$dan->{influence}};
		for(@inf){$dan->{influence}->{$_}=1}
	}
	return@a;
 }


 ## Kill -  
 #   ,      .
sub Kill
 {
	my$dan=shift;
	$dan->Cache;
	_closev($dan,'index');
	if($dan->{basebody}){_closev($dan,'body')}
	undef%{$dan};
	return 1;
 }


 ## Languages - /   
 # ($defaultlang,@langs)=Languages()
 # $defaultlang - ,     ,
 # @langs - ,   ,  
 #     RFC-1766 (ISO 839-1).   
 #    .
 #
 # 
 # Languages(langdefault,lang1,lang2,lang3,lang4, ...)
 # langdefault - ,   ,   .
 #  ,     ,  
 #     .
 #   .
sub Languages
 {
	my$dan=shift;
	my@a=@_;

	if(@a)	# 
	{
		my@b=($dan->{defaultlanguage},@{$dan->{languages}});

		$dan->{defaultlanguage}=shift@a;

		my%a;for(@a){$a{$_}=1}
		delete$a{$dan->{defaultlanguage}};
		@{$dan->{languages}}=keys%a;

		return@b;
	}
	else
	{
		return($dan->{defaultlanguage},@{$dan->{languages}});
	}

 }

sub LinkExists
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;

	return $dan->PropertyLink($doi,$role);
 }

sub LinkValue
 {
	my$dan=shift;
	my$doi1=shift;
	my$doi2=shift;
	my$role12=shift;
	my$value=shift;

	my%b=split(/\x00/,_getv("${doi1}_$role12",$dan->{baseindex},$dan));
	my$b=$b{$doi2};
	if($value && $b)
	{
		$b{$doi2}=$value;
		_putv("${doi1}_$role12",join(chr(0),%b),$dan->{baseindex},$dan);
	}
	return$b
 }

sub ModelId
 {
	my$dan=shift;
	return$dan->{model}
 }

sub ModelName
 {
	my$dan=shift;
	my$a=shift;
	if($a){$dan->{danname}=$a}
	return$dan->{danname}
 }

sub ModifyDate
 {
	my$dan=shift;
	my$a=shift;
	if($a){$dan->{modifydate}=$a}
	return$dan->{modifydate}
 }

sub PropertyBody
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my($dti,$don)=split(/:/,$doi);
	unless($dti){return}
	my$body=shift;
	my($a);

	my@a=@{$dan->{currentlanguage}};
	unless($dan->{influence}->{$dti}){@a=('')}

	for(@a)
	{
		if($a=_getv("${_}$doi",${$dan}{basebody},$dan)){last}
	}

	if($body && $body ne '-')
	{
		_putv("$a[0]$doi",$body,${$dan}{basebody},$dan);
		if($a[0] && ($a[0] eq "$dan->{defaultlanguage}\$")){_putv($doi,$body,${$dan}{basebody},$dan)}
	}
	elsif($body eq '-')
	{
		for(@{$dan->{languages}},$dan->{defaultlanguage},'')
		{
			if($_){$_.='$'}
			_delv("$_$doi",${$dan}{basebody},$dan)
		}
	}
	return$a
 }

sub PropertyCounter
 {
	my$dan=shift;
	my$dti=shift;
	unless($dti){return}
	my$counter=shift;$counter*=1;

	my@a=split(/\x01/,$dan->{counter}->{$dti});
	if($counter)
	{
		$a[0]+=$counter;
		if($counter>0){$a[1]+=$counter}
		$dan->{counter}->{$dti}=join(chr(1),@a);
		_putv("x_counter_$dan->{model}",join(chr(0),%{$dan->{counter}}),$dan->{baseindex},$dan)

	}
	return$a[0]
 }

sub PropertyCounterAll
 {
	my$dan=shift;
	my$dti=shift;
	unless($dti)
	{
		return _getv('__propertylast',$dan->{baseindex},$dan);
	}
	my$counter=shift;$counter*=1;

	return (split(/\x01/,$dan->{counter}->{$dti}))[1] || 0;
 }

sub PropertyId
 {
	my$dan=shift;
	my$dti=$dan->TypeId(shift);
	my$name=shift;
	return unless $name;
	my($a);

	my@a=@{$dan->{currentlanguage}};
	unless($dan->{influence}->{$dti}){@a=('')}
	for(@a){if($a=_getv("oi_${_}$dti:$name",$dan->{baseindex},$dan)){last}}

	return $a
 }

sub PropertyLast
 {
	my$dan=shift;
	return sprintf($BASE,_getv('__propertylast',$dan->{baseindex},$dan)*1);
 }

sub PropertyLink
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	if($role)
	{
		return (split(/\x00/,_getv("${doi}_$role",$dan->{baseindex},$dan)))[0];
	}
	my@links=split(/\x00/,_getv($doi,$dan->{baseindex},$dan));
	return (split(/\x00/,_getv("${doi}_".$links[0],$dan->{baseindex},$dan)))[0] || '';
 }

sub PropertyLinkProperty
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	my($a,@links);

	unless($a=$dan->PropertyLink($doi,$role)){return}
	return $dan->PropertyName($a);
 }

sub PropertyLinks
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	my(%links);

	if($role)
	{
		%links=split(/\x00/,_getv("${doi}_$role",$dan->{baseindex},$dan));
	}
	else
	{
		%links=split(/\x00/,_getv($doi,$dan->{baseindex},$dan));
	}
	my@links=keys%links;

	return\@links
 }

sub PropertyLinksProperty
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	my($links,%a,@links);

	if($role)
	{
		if(my$links=$dan->PropertyLinks($doi,$role))
		{
			for(@{$links})
			{
				$a{$_}=$dan->PropertyName($_);
			}
		}
	}
	return\%a
 }

sub PropertyLinksStructure
 {
	my$dan=shift;
	my$doi=shift;
	my($a,$i,@a,$b,%a);

	@a=split(/\x00/,_getv($doi,$dan->{baseindex},$dan));
	for(@a)
	{
		%{$b->{$_}}=split(/\x00/,_getv("${doi}_$_",$dan->{baseindex},$dan));
	}
	return$b

 }

sub PropertyLinkSort
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	my(%links);
	if($role)
	{
		my%links=split(/\x00/,_getv("${doi}_$role",$dan->{baseindex},$dan));
		return (sort{$dan->PropertyName($a) cmp $dan->PropertyName($b)}keys%links)[0];
	}
	%links=split(/\x00/,_getv($doi,$dan->{baseindex},$dan));
	%links=(split(/\x00/,_getv("${doi}_".(keys%links)[0],$dan->{baseindex},$dan)))[0];
	return (sort{$dan->PropertyName($a) cmp $dan->PropertyName($b)}keys%links)[0] || '';
 }

sub PropertyLinkSortProperty
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	my($a,@links);

	unless($a=$dan->PropertyLinkSort($doi,$role)){return}
	return $dan->PropertyName($a);
 }

sub PropertyLinkValue
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$role=shift;
	unless($role){return}
	my$value=shift;
	my$a=$dan->PropertyLink($doi,$role);
	my$b=$dan->LinkValue($doi,$a,$role);
	if($value){$dan->LinkValue($doi,$a,$role,$value)}
	return$b;
 }

sub PropertyList
 {
	my$dan=shift;
	my$dti=shift;
	my$obj=shift;
	if($obj)
	{
		my$number=shift;
		my$first=shift;
		my$direction=shift;
		my$last=shift;
		if($direction){$direction=R_PREV}else{$direction=R_NEXT}

		my@a=@{$dan->{currentlanguage}};
		unless($dan->{influence}->{$dti}){@a=('')}

		return _listvalue("oi_$a[0]$dti:$obj",$dan->{baseindex},$number,"oi_$a[0]$dti:$first",$direction,($last?"oi_$a[0]$dti:$last":''));
	}
 }


sub PropertyName
 {
	my$dan=shift;
	my$dti=shift;
	my($don,$a,@a);
	($dti,$don)=split(/:/,$dti);
	$don||=shift;
	if(!$don || !$dti){return}
	unless($dti=$dan->TypeId($dti)){return}
	$don="$dti:$don";

	unless($dan->{influence}->{$dti}){@a=('')}else{@a=@{$dan->{currentlanguage}}}
	for(@a)
	{
		if($a=_getv("on_${_}$don",$dan->{baseindex},$dan)){last}
	}
	return$a
 }

sub PropertyNextId
 {
	my$dan=shift;
	my$dti=shift;
	my$first=shift;
	my@a=@{$dan->{currentlanguage}};
	unless($dan->{influence}->{$dti}){@a=('')}

	$first=~s/^on_$a[0]$dti://;
	$first=_listvalue("on_$a[0]$dti:",$dan->{baseindex},2,"on_$a[0]$dti:$first",R_NEXT);
	$first->[1]=~s/^on_$a[0]//;
	return$first->[1]
 }

sub PropertyNextName
 {
	my$dan=shift;
	my$dti=shift;
	my$first=shift;
	my@a=@{$dan->{currentlanguage}};
	unless($dan->{influence}->{$dti}){@a=('')}

	$first=~s/^oi_$a[0]$dti://;
	$first=_listvalue("oi_$a[0]$dti:",$dan->{baseindex},2,"oi_$a[0]$dti:$first",R_NEXT);
	$first->[1]=~s/^oi_$a[0]$dti://;
	return$first->[1]
 }

sub PropertyPrevId
 {
	my$dan=shift;
	my$dti=shift;
	my$first=shift;
	my@a=@{$dan->{currentlanguage}};
	unless($dan->{influence}->{$dti}){@a=('')}

	$first=~s/^on_$a[0]$dti://;
	$first=_listvalue("on_$a[0]$dti:",$dan->{baseindex},2,"on_$a[0]$dti:$first",R_PREV);
	$first->[1]=~s/^on_$a[0]//;
	return$first->[1]
 }

sub PropertyPrevName
 {
	my$dan=shift;
	my$dti=shift;
	my$first=shift;
	my@a=@{$dan->{currentlanguage}};
	unless($dan->{influence}->{$dti}){@a=('')}

	$first=~s/^oi_$a[0]$dti://;
	$first=_listvalue("oi_$a[0]$dti:",$dan->{baseindex},2,"oi_$a[0]$dti:$first",R_PREV);
	$first->[1]=~s/^oi_$a[0]$dti://;
	return$first->[1]
 }

 #    
sub Repair
 {
	my$dan=shift;

	return
 }

 # Role2Role -       
 # Role2Role($fromtype,$fromrole,$totype,$torole,$mode)
sub Role2Role
 {
	my$dan=shift;
	my$fromtype=shift;
	my$fromrole=shift;
	my$totype=shift;
	my$torole=shift;
	my$mode=shift;	#  'false',   ,   
				#	  
				#  'true',   
	my($i,$cnt);

	if(!$fromtype ||!$fromrole || !$totype || !$torole){return}

	if($dan->RoleType($fromrole)!=$fromtype || $dan->RoleType($torole)!=$totype){return}

	my$a=$dan->TypeList($fromtype);

	for$i(@{$a})
	{
		if(my@a=@{$dan->PropertyLinks($i,$dan->RoleCorr($fromrole))})
		{

			my$name=$dan->PropertyName($i);
			my$body=$dan->PropertyBody($i);
			my$newid=$dan->SetProperty($totype,$name,$body);
			for(@a)
			{
				$dan->SetLink($_,$newid,$torole);
				unless($mode)
				{
					$dan->VerifyProperty($dan->DeleteLink($_,$i,$fromrole));
					unless($dan->PropertyLink($i)){$dan->DeleteProperty($i)}
				}
			}
			++$cnt;
		}
	}

	return$cnt
 }

sub RoleAlias
 {
	my$dan=shift;
	my$role=shift;
	my$alias=shift;
	if($alias){$dan->{rolealias}->{$role}=$alias}
	return$dan->{rolealias}->{$role}
 }

sub RoleCorr
 {
	my$dan=shift;
	my$role=shift;
	return$dan->{rolecorr}->{$role}
 }

sub RoleId
 {
	my$dan=shift;
	my$role=shift;
	unless($role=~/^\d+$/){$role=$dan->{roleid}->{$role}}
	return$role
 }

sub RoleName
 {
	my$dan=shift;
	my$role=shift;
	if($role=~/^\d+$/){$role=$dan->{rolename}->{$role}}
	return$role
 }

sub RoleRest
 {
	my$dan=shift;
	my$role=shift;
	my$rest=shift;
	if(length$rest){if($rest){$dan->{rolerest}->{$role}=$rest}else{delete$dan->{rolerest}->{$role}}}
	return$dan->{rolerest}->{$role}
 }

sub Roles
 {
	my$dan=shift;
	my$dti=shift;
	if($dti)
	{
		my@a;
		for(keys%{$dan->{role}->{$dti}}){push@a,keys %{$dan->{role}->{$dti}->{$_}}}
		return @a
	}
	else
	{
		return keys%{$dan->{rolecorr}}
	}
	return
 }

sub RoleType
 {
	my$dan=shift;
	my$role=shift;
	return$dan->{typerole}->{$role}->[1]
 }

sub RoleTypeBack
 {
	my$dan=shift;
	my$role=shift;
	return$dan->{typerole}->{$role}->[0]
 }

sub RoleVector
 {
	my$dan=shift;
	my$role=shift;
	return$dan->{rolevector}->{$role}
 }

 ## SaveModel -   
 # SaveModel(dan)
 # dan -   
sub SaveModel
 {
	my$dan=shift;
	my($i,$j,@a);


 #   
	_putv("x_type_$dan->{model}",join(chr(0),%{$dan->{type}}),$dan->{baseindex},$dan);
 #   
	_putv("x_typealias_$dan->{model}",join(chr(0),%{$dan->{typealias}}),$dan->{baseindex},$dan);
 #   
	_putv("x_typerest_$dan->{model}",join(chr(0),%{$dan->{typerest}}),$dan->{baseindex},$dan);
 #   
	_putv("x_rolename_$dan->{model}",join(chr(0),%{$dan->{rolename}}),$dan->{baseindex},$dan);
 #   
	_putv("x_rolealias_$dan->{model}",join(chr(0),%{$dan->{rolealias}}),$dan->{baseindex},$dan);
 #   
	_putv("x_rolevector_$dan->{model}",join(chr(0),%{$dan->{rolevector}}),$dan->{baseindex},$dan);
 #   
	_putv("x_rolecorr_$dan->{model}",join(chr(0),%{$dan->{rolecorr}}),$dan->{baseindex},$dan);
 #    
	_putv("x_rolerest_$dan->{model}",join(chr(0),%{$dan->{rolerest}}),$dan->{baseindex},$dan);
 #   
	if(@{$dan->{languages}}){my$a=join(chr(1),%{$dan->{influence}});_putv("x_languages_$dan->{model}",join(chr(0),$dan->{defaultlanguage},$a,@{$dan->{languages}},''),$dan->{baseindex},$dan)}

	for$i(keys%{$dan->{role}})
	{
		my@b=();
		for$j(keys%{$dan->{role}->{$i}})
		{
			for(keys%{$dan->{role}->{$i}->{$j}})
			{
				unless($dan->RoleName($_)){delete$dan->{role}->{$i}->{$j}->{$_}}
			}
			push@b,join(chr(2),$j,%{$dan->{role}->{$i}->{$j}});

		}
		push@a,join(chr(1),$i,@b);
	}
	_putv("x_model_$dan->{model}",join(chr(0),@a),$dan->{baseindex},$dan);


 #    
	@a=();
	$a[0]=$dan->{createdate};
	$a[1]=$dan->{description};
	$a[2]=$dan->{modifydate};
	$a[3]=$dan->{danname};

	_putv("x_info_$dan->{model}",join(chr(0),@a),$dan->{baseindex},$dan);

	return 1;
 }


 ## SaveObject -  ,    
 # $doi=SaveObject($maintype,$name,$body,\%propertys)
 # maintype	-  ,    
 #			   
 # name	-  
 # body	-  ,     , 
 #			     ,   
 # propertys	-        
 # doi		-    (  maintype)
 #		0 -   ,  $!   
sub SaveObject
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$name=shift;
	my$b=shift;
	my($pro,$a,%prop)=@_;my($body,$i,$j,$props,$dti,$don);

 #     ,    
	if(ref$b eq 'ARRAY'){$body=$b}
 #      - 
	elsif(ref$b eq 'SCALAR'){$body->[0]=$$b}
 #     
	else{$body->[0]=$b}
	undef$b;

 #     
	unless(ref$pro eq 'HASH')
	{	
		$prop{$pro}=$a;
		$props=\%prop;
	}
 #    
	else{$props=$pro}


 #     
	($dti,$don)=split(/:/,$doi);
	unless($dti=~/^\d+$/){$dti=$dan->TypeId($dti)}
	if($don=~/^[\dxA-Fa-f]+$/){$doi="$dti:$don"}else{undef$doi}
 #	unless(${$props}{$maintype}){$!='Main type property not defined.';return}

 #    
	for(keys%{$props})
	{
		unless($props->{$_}){delete$props->{$_};next}
		unless(/^\d+$/)
		{
			unless($dan->RoleId($_)){croak "DAN error: role vector '$_' incorrect";return}
			$props->{$dan->{rolecorr}->{$dan->RoleId($_)}}=$props->{$_};
			delete$props->{$_};
			$_=$dan->{rolecorr}->{$dan->RoleId($_)}
		}
		unless(ref($props->{$_}) eq 'ARRAY')
		{
			my$a;
			$a=$props->{$_};
			delete$props->{$_};
			push@{$props->{$_}},$a;
		}
	}
 #      
	for$i(keys%{$props})
	{
		my$links;
		my$type=$dan->RoleTypeBack($i);
		for(@{$props->{$i}})
		{
			unless($_){next}
			my$j=$dan->RoleType($i);
 #  -      
			if($dan->{role}->{$dti}->{$j}->{$i})
			{
 #     
				if(ref$_ eq 'SCALAR')
				{
					if($dan->PropertyName(${$_})){$_=${$_}}
					else{undef$_}
				}
				else
				{
 #        
					my$a=$dan->Exists($j,$_);
					$a||=$dan->SetProperty($j,$_);
					$_=$a;
				}
			}
			else{undef$_}

		}
	}
 #    
	for$i(keys%{$props})
	{
		my%a;
		for(@{$props->{$i}}){$a{$_}=1}
 #		delete$props->{$i};
		$props->{$i}=\%a;
	}
 #   
	unless($don)
	{
 # ,   
		$doi=$dan->Exists($dti,$name,join('',@$body),$props);
 #  
		$doi||=$dan->SetProperty($dti,$name,join('',@$body),$props);
	}
	else
	{
 #      
		$doi=$dan->SetProperty($doi,$name,join('',@$body),$props);
	}
	return $doi;
 }


sub SetPoint
 {
	my$dan=shift;
	if($DEBUG){print A "==========================================\n"}
 }

 ## SetLanguage -   
 # SetLanguage(lang [,mode])
 #    .     
 #     RFC-1766 (ISO 839-1).    
 #          (
 #    Languages).    
 #  ,    ,    
 #   .   $mode,   
 # (   )     (  ,
 #       - ).
 #   .
sub SetLanguage
 {
	my$dan=shift;
	my$lang=shift;
	my$mode=shift;

	my$old=${$dan->{currentlanguage}}[0];

	if($lang)
	{
		my@a=$dan->Languages();
		my@b;
		for(@a){if($lang eq $_){push@b,$lang.'$';last}}
		unless($mode)
		{
			if($DAN::LANGTAKEDEFAULT && $dan->{defaultlanguage} && ($dan->{defaultlanguage} ne $lang)){push@b,$dan->{defaultlanguage}.'$'}
			push@b,'';
		}
		@{$dan->{currentlanguage}}=@b;
	}
	else
	{
		@{$dan->{currentlanguage}}=('');
	}
	return$old;
 }


 ## SetLink -  
 # SetLink(doi1,doi2,role)
 #     doi1  doi2    role.
 #        .
sub SetLink
 {
	my$dan=shift;
	my$doi1=shift;
	my$doi2=shift;
	my$role12=shift;
	my$value12=shift;
	my(%a,%b,$role21,$roles,$a,$oldlink);

	$role21=$dan->{rolecorr}->{$role12};
	if(!$doi1||!$doi2||!$role12||!$role21){return}

	if(!$dan->{rolerest}->{$role21} && (!$dan->{rolerest}->{$role12} || ($dan->{rolerest}->{$role12} && !_getv("${doi2}_$role21",$dan->{baseindex},$dan))))			# 
	{
		_addlink($dan,$doi1,$doi2,$role12,$value12);
		_addlink($dan,$doi2,$doi1,$role21);
		$oldlink=1
	}
	elsif($dan->{rolerest}->{$role21} == 1)		# 
	{
		$oldlink=(split(/\x00/,_getv("${doi1}_$role12",$dan->{baseindex},$dan)))[0];

		if($oldlink)
		{
			_deletelink($dan,$doi1,$oldlink,$role12);
			_deletelink($dan,$oldlink,$doi1,$role21);
		}
		_addlink($dan,$doi1,$doi2,$role12,$value12);
		_addlink($dan,$doi2,$doi1,$role21);

	}
	elsif($dan->{rolerest}->{$role21} == 2 && !_getv("${doi1}_$role12",$dan->{baseindex},$dan))
	{
		_addlink($dan,$doi1,$doi2,$role12,$value12);
		_addlink($dan,$doi2,$doi1,$role21);
		$oldlink=1
	}
	else{return}	# 
	return$oldlink;
 }

 ## SetProperty -  
 # $doi=SetProperty(doi,name,body,links)
 #   ,   name.
 #  doi     ,  
 # ;     doi  , 
 #     body;  doi  ,
 #     name.
 #   body,     dan3.
 #   links,  .
 #     doi .
sub SetProperty
 {
	my$dan=shift;
	my$doi=shift;
	unless($doi){return}
	my$name=shift;
	my$body=shift;
	my$links=shift;
	my($b,$name1,$exists,$c,$d,$dti,$don,$i,@a);

	($dti,$don)=split(/:/,$doi);
	if(!$dti||!length$name){return ''}

	unless($dan->{influence}->{$dti}){@a=('')}else{@a=@{$dan->{currentlanguage}}}

	($name1=$name)=~s/\x01(\d+)$//;
 #  
	unless(length$don)
	{
 A1:
		$c='';
		if((($b=$dan->PropertyId($dti,$name1)) && !$dan->{typerest}->{$dti}) || !$b)
		{
			$d=0;
			while($dan->PropertyId($dti,"$name1$c")){$c=chr(1).(++$d)}
			$b=$dan->_propertylast;
			$dan->PropertyCounter($dti,1);
		}

		_putv("oi_$a[0]$dti:$name1$c",$b,$dan->{baseindex},$dan);
		_putv("on_$a[0]$dti:$b","$name1$c",$dan->{baseindex},$dan);
		if($dan->{basebody}&&$body){_putv("$a[0]$dti:$b",$body,$dan->{basebody},$dan)}

		if($a[0] && ($a[0] eq $dan->{defaultlanguage}."\$"))
		{
			_putv("oi_$dti:$name1$c",$b,$dan->{baseindex},$dan);
			_putv("on_$dti:$b","$name1$c",$dan->{baseindex},$dan);
			if($dan->{basebody}&&$body){_putv("$dti:$b",$body,$dan->{basebody},$dan)}
		}

		$doi="$dti:$b";
	}
 #  ID  - 
	elsif(!$don)
	{
		$b=$dan->PropertyId($dti,$name);
		unless($b=$dan->PropertyId($dti,$name)){goto A1}

		my$c=$dan->PropertyName($b);
		unless($c)
		{
			for(@a)
			{
				_delv("on_${_}$b",$dan->{baseindex},$dan);
				if($dan->{basebody}){_delv("${_}$b",$dan->{basebody},$dan)}
			}
			goto A1
		}

		$doi="$dti:$b";
	}
 #   ,     
	elsif($name && ($dan->{typerest}->{$dti} != 2))
	{
		$b=$dan->PropertyName("$dti:$don");
		unless($dan->{typerest}->{$dti} && $dan->PropertyId($dti,$name1))
		{
			_delv("oi_$a[0]$dti:$b",$dan->{baseindex},$dan);
			$c='';$d=0;while($dan->PropertyId($dti,"$name1$c")){$c=chr(1).(++$d)}

			_putv("oi_$a[0]$dti:$name1$c",$don,$dan->{baseindex},$dan);
			_putv("on_$a[0]$dti:$don","$name1$c",$dan->{baseindex},$dan);

			if($dan->{basebody}&&$body){_putv("$a[0]$dti:$don",$body,$dan->{basebody},$dan)}

			if($a[0] && ($a[0] eq "$dan->{defaultlanguage}\$"))
			{
				_delv("oi_$dti:$b",$dan->{baseindex},$dan);
				_putv("oi_$dti:$name1$c",$don,$dan->{baseindex},$dan);
				_putv("on_$dti:$don","$name1$c",$dan->{baseindex},$dan);
				if($dan->{basebody}&&$body){_putv("$dti:$don",$body,$dan->{basebody},$dan)}
			}
		}
	}

 #  
	if($links)
	{
		for$i(keys%{$links})
		{
			for(keys%{$links->{$i}})
			{
				if($links->{$i}->{$_}){$dan->SetLink($doi,$_,$i)}
				else{$dan->DeleteLink($doi,$_,$i)}
			}
		}
	}

	return$doi;
 }

 ## SetRole -        
 # $roleid=SetRole(dti1,dti2,rolename12,rolename21)
 #    rolename12,   
 # dti1      dti2.
 #     ,  
 # :    :
 #	SetRole(dti1,dti2,rolename12,rolename21)
 # 
 #	SetRole(dti2,dti1,rolename21,rolename12)
 #      
sub SetRole
 {
	my$dan=shift;
	my($dti1,$dti2,$r12,$r21)=@_;my($b,$c);

	unless($b=$dan->{roleid}->{"$dan->{type}->{$dti1}.$r12.$dan->{type}->{$dti2}.$r21"})
	{
		$b=$dan->_rolelast;

		$dan->{roleid}->{"$dan->{type}->{$dti1}.$r12.$dan->{type}->{$dti2}.$r21"}=$b;
		$c=$dan->SetRole($dti2,$dti1,$r21,$r12);

		$dan->{rolevector}->{$b}=join('.',$dan->{type}->{$dti1},$r12,$dan->{type}->{$dti2},$r21);
	}
	else
	{
		$c=$dan->{roleid}->{"$dan->{type}->{$dti2}.$r21.$dan->{type}->{$dti1}.$r12"};
	}
	$dan->{role}->{$dti1}->{$dti2}->{$b}=$c;
	$dan->{rolecorr}->{$b}=$c;
	$dan->{rolename}->{$b}=$r12;

	return$b
 }

 ## SetType -   
 # $dti=SetType(name)
 #   , 
 #   name
 #     ,  
sub SetType
 {
	my$dan=shift;
	my$a=shift;
	my($b);
	if($b=$dan->{typename}->{$a}){$dan->{type}->{$b}=$a;return$b}
	$b=$dan->_typelast;

	$dan->{type}->{$b}=$a;
	$dan->{typename}->{$a}=$b;
	return$b
 }


 ## SwapLang -  ,  ,   
 #
sub SwapLang
 {
	my$dan=shift;
	my$dti=shift;
	my$name=shift;
	my$destlang=shift;
	my$srclang=shift||$dan->GetLanguage||$dan->{defaultlanguage};


	my$old=$dan->SetLanguage($srclang);
	my$a=$dan->PropertyId($dti,$name);
	if($a)
	{
		$dan->SetLanguage($destlang);
		return$dan->PropertyName("$dti:$a");
	}
	return
 }


sub Switch2RO
 {
	my$dan=shift;
	my$mode=shift;	# mode=1 -  , mode=2 -  body
	if($dan->{_index_id} && !$dan->{'_base_index_r'} && (!$mode || $mode==1))
	{
		_closev($dan,'index');
		$dan->{baseindex}=_openv_r($dan,$dan->{_index_id},'index');
	}
	if($dan->{basebody} && $dan->{_body_id} && !$dan->{'_base_body_r'} && (!$mode || $mode==2))
	{
		_closev($dan,'body');
		$dan->{basebody}=_openv_r($dan,$dan->{_body_id},'body');
	}
	return 1;
 }

sub Switch2RW
 {
	my$dan=shift;
	my$mode=shift;
	if($dan->{_index_id} && !$dan->{'_base_index_w'} && (!$mode || $mode==1))
	{
		_closev($dan,'index');
		$dan->{baseindex}=_openv($dan,$dan->{_index_id},'index');
	}
	if($dan->{basebody} && $dan->{_body_id} && !$dan->{'_base_body_w'} && (!$mode || $mode==2))
	{
		_closev($dan,'body');
		$dan->{basebody}=_openv($dan,$dan->{_body_id},'body');
	}
	return 1;
 }

sub TypeAlias
 {
	my$dan=shift;
	my$dti=shift;
	my$alias=shift;
	if($alias){$dan->{typealias}->{$dti}=$alias}
	return$dan->{typealias}->{$dti}
 }

sub TypeId
 {
	my$dan=shift;
	my$type=shift;
	unless($type=~/^\d+$/){$type=$dan->{typename}->{$type}}
	return$type
 }

sub TypeList
 {
	my$dan=shift;
	my$dti=shift;
	my($i,%b,@c);
	if($dti)
	{
		my$number=shift;
		my$first=shift;
		my$direction=shift;
		my$last=shift;
		if($direction){$direction=R_PREV}else{$direction=R_NEXT}
		my($propertys);

		my$b=_listvalue("on_$dti:",$dan->{baseindex},$number,"on_$dti:$first",$direction,($last?"on_$dti:$last":''));
		for(@{$b}){s/^on_//}
		return$b;
	}
	else{return $dan->Types}
 }

sub TypeListName
 {
	my$dan=shift;
	my$dti=shift;
	my($i,%b,@c);

	if($dti)
	{
		my$number=shift;
		my$first=shift;
		my$direction=shift;
		my$last=shift;
		if($direction==1){$direction=R_PREV}elsif($direction==0){$direction=R_NEXT}
		my($propertys);

		for(@{$dan->{currentlanguage}})
		{
			my$b=_listvalue("oi_$_$dti:",$dan->{baseindex},$number,"oi_$_$dti:$first",$direction,($last?"oi_$_$dti:$last":''));
			for$i(@{$b}){$i=~s/^oi_\Q$_$dti://;if($i && !$b{$i}){$b{$i}=1;push@c,$i}}
		}
		return \@c
	}
	else{return $dan->Types}
 }

sub TypeName
 {
	my$dan=shift;
	my$dti=shift;
	if($dti=~/^\d+$/){$dti=$dan->{type}->{$dti}}
	return$dti
 }

sub TypeRest
 {
	my$dan=shift;
	my$dti=shift;
	my$rest=shift;
	if(length$rest)
	{
		if($rest){$dan->{typerest}->{$dti}=$rest}
		else{delete$dan->{typerest}->{$dti}}
	}
	return$dan->{typerest}->{$dti}
 }

sub Types
 {
	my$dan=shift;
	return keys%{${$dan}{type}}
 }

sub VerifyProperty
 {
	my$dan=shift;
	my$doi=shift;
	my($dti);

	unless($doi){return}
	unless($doi=~/(\d+):[a-f\dx]+/i){return}

	unless(_getv($doi,$dan->{baseindex},$dan))
	{
		return $dan->DeleteProperty($doi);
	}
	return
 }

sub Version
 {
	my$dan=shift;
	return$dan->VERSION
 }


sub _addlink
 {
	my$dan=shift;
	my$doi1=shift;
	my$doi2=shift;
	my$role12=shift;
	my$value12=shift;

	my($b);
	$b=_getv("${doi1}_$role12",$dan->{baseindex},$dan);
	my%b=split(/\x00/,$b);
	$b{$doi2}=$value12||1;
	_putv("${doi1}_$role12",join(chr(0),%b),$dan->{baseindex},$dan);

	unless($b)
	{
		%b=split(/\x00/,_getv($doi1,$dan->{baseindex},$dan));
		$b{$role12}=1;
		_putv($doi1,join(chr(0),%b),$dan->{baseindex},$dan);
	}
	return
 }

sub _deletelink
 {
	my$dan=shift;
	my$doi1=shift;
	my$doi2=shift;
	my$role12=shift;

	my($b);
	my%b=split(/\x00/,_getv("${doi1}_$role12",$dan->{baseindex},$dan));

	delete$b{$doi2};
	$b=join(chr(0),%b);
	_putv("${doi1}_$role12",$b,$dan->{baseindex},$dan);

	unless($b)
	{
		%b=split(/\x00/,_getv($doi1,$dan->{baseindex},$dan));
		delete$b{$role12};
		$b=join(chr(0),%b);
		if($b){_putv($doi1,$b,$dan->{baseindex},$dan)}
		else{_delv($doi1,$dan->{baseindex},$dan)}
	}
	return
 }

sub _propertylast
 {my$dan=shift;my$a=_getv('__propertylast',$dan->{baseindex},$dan)*1+1;_putv('__propertylast',$a,$dan->{baseindex},$dan);return sprintf($BASE,$a)}

sub _rolelast
 {my$dan=shift;my$a=_getv('__rolelast',$dan->{baseindex},$dan)*1+1;_putv('__rolelast',$a,$dan->{baseindex},$dan);return$a}

sub _typelast
 {my$dan=shift;my$a=_getv('__typelast',$dan->{baseindex},$dan)*1+1;_putv('__typelast',$a,$dan->{baseindex},$dan);return$a}

sub _openv
 {
	my$dan=shift;
	my$file=shift;		#  
	my$type=shift;		#  
	my($b,$cnt,$id);

	$id='A'.int(rand($$+localtime));
	until($b=tie(%{$dan->{"_values_$type"}},'DB_File',$file,O_RDWR|O_CREAT,0640,$DB_BTREE))
	{
		$id='A'.int(rand($$+localtime));
		sleep 1;if(++$cnt > 10)
		{
			croak "DAN error: unable to open database";return
		}
	}
	$dan->{"_base_$type"}=$id;
	$dan->{"_file_$type"}=$file;
	$dan->{"_base_${type}_w"}=1;
	delete$dan->{"_base_${type}_r"};

	if($DEBUG){print A "open: $id,$file {$type}\n"}
	if($FLOCK)
	{
		my$fd=$b->fd;
		open("DB_$id","+<&$fd");
		flock("DB_$id",LOCK_EX);
		if($DEBUG){print A "lock: $id,$file {$type}\n"}
	}
	$dan->{"base$type"}=$b;
	if($TRANSACTIONS && !$dan->{transactions})
	{
		$dan->{transactions}=$file.'.log';
		open DANLOG,">>".$dan->{transactions};
		my$i=localhost;
		print DANLOG "# runned by $0 at $i\n";
	}

	return$b;
 }

sub _openv_r
 {
	my$dan=shift;
	my$file=shift;		#  
	my$type=shift;		#  
	my($b,$cnt,$id);

	$id='A'.int(rand($$+localtime));
	until($b=tie(%{$dan->{"_values_$type"}},'DB_File',$file,O_RDWR|O_CREAT,0640,$DB_BTREE))
	{
		$id='A'.int(rand($$+localtime));
		sleep 1;if(++$cnt > 10)
		{
			croak "DAN error: unable to open database";return
		}
	}
	$dan->{"_base_$type"}=$id;
	$dan->{"_base_${type}_r"}=1;
	delete$dan->{"_base_${type}_w"};
	if($DEBUG){print A "open_ro: $id,$file {$type}\n"}
	$dan->{"base$type"}=$b;
	return$b;
 }

sub _closev
 {
	my$dan=shift;
	my$type=shift;
	my$id=$dan->{"_base_$type"};
	if($FLOCK && $type){flock("DB_$id",LOCK_UN);if($DEBUG){print A "unlock: $id,$file {$type}\n"}}

	undef$dan->{"base$type"};
	untie(%{$dan->{"_values_$type"}});
	if($type){close("DB_$id")}
	delete$dan->{"_base_${type}_w"};
	delete$dan->{"_base_${type}_r"};
	if($DEBUG){print A "close: $id {$type}\n"}

	return;
 }


 # length -   ,   
sub _listvalue
 {
	my($key,$base,$length,$first,$direction,$last)=@_;my($crit,$rc,$val,@a,$i);
	$direction||=R_NEXT;
	$crit=$key;
	if($first){$key=$first}

	for(	$rc=$base->seq($key,$val,R_CURSOR);
		$rc==0 && $key=~/^\Q$crit/;
		$rc=$base->seq($key,$val,$direction)
	)
	{
		if(($base eq $dan->{baseindex}) && exists$dan->{cache}->{$key}){$val=$dan->{cache}->{$key}}
		elsif(($base eq $dan->{basebody}) && exists$dan->{cachebody}->{$key}){$val=$dan->{cachebody}->{$key}}

		push@a,$key;
		if($DEBUG){print A "list[$first-$last]: $key {",length$val,"}\n"}
		if($length&&($i++ > $length)){last}
		if($last && ($key ge $last)){last}
	}
	return\@a
 }

sub _getv
 {
	my($key,$base,$dan)=@_;my($val);

	if($base eq $dan->{basebody})
	{
		if($dan->{cacheenabled} && exists$dan->{cachebody}->{$key})
		{
			$val=$dan->{cachebody}->{$key};
			if($DEBUG){print A "cache_read_body_$dan->{_base_body}: $key {",length$val,"}\n"}
		}
		else
		{
			$base->get($key,$val);
			if($DEBUG){print A "read_body_$dan->{_base_body}: $key {",length$val,"}\n"}
		}
		return$val
	}

	if($dan->{cacheenabled} && exists$dan->{cache}->{$key})
	{
		if(($val=$dan->{cache}->{$key}) && $DEBUG){print A "cache_read_$dan->{_base_index}: $key {",length$val,"}\n"}
	}
	else
	{	$base->get($key,$val);
		if($DEBUG){print A "read_$dan->{_base_index}: $key {",length$val,"}\n"}
	}

	return$val;
 }

sub _putv
 {
	my($key,$val,$base,$dan)=@_;my($val1);

	unless($val)
	{
		return _delv($key,$base,$dan)
	}
	else
	{
		if($base eq $dan->{basebody})
		{
			if($dan->{cacheenabled})
			{
				$dan->{cachebody}->{$key}=$val
			}
			else
			{
				$val1=$base->put($key,$val);
			}
			if($DEBUG){print A "save_body_$dan->{_base_body}: $key {",length$val,"}\n"}

			if($TRANSACTIONS){print DANLOG "sb:$key ",_codec_qp(\$val),"\n"}
			return$val1
		}

		if($dan->{cacheenabled})
		{
			$dan->{cache}->{$key}=$val
		}
		else
		{
			$val1=$base->put($key,$val);
		}
		if($DEBUG){print A "save_$dan->{_base_index}: $key {",length$val,"}\n"}
		if($TRANSACTIONS){print DANLOG "si:$key $val\n"}
		return$val1;
	}
 }

sub _delv
 {
	my($key,$base,$dan)=@_;my($val1);

	if($base eq $dan->{basebody})
	{
		if($dan->{cacheenabled}){$dan->{cachebody}->{$key}=''}
		else
		{
			$val1=$base->del($key);
		}
		if($DEBUG){print A "del_body_$dan->{_base_body}: $key\n"}
		if($TRANSACTIONS){print DANLOG "db:$key\n"}
		return$val1
	}

	if($dan->{cacheenabled}){$dan->{cache}->{$key}=''}
	else
	{
		$val1=$base->del($key);
	}
	if($DEBUG){print A "del_$dan->{_base_index}: $key\n"}

	if($TRANSACTIONS){print DANLOG "di:$key\n"}
	return$val1;
 }


sub _crc32
 {
	my$dan=shift;
	my($a)=@_;my($crc,$i,$j,$b);
 #   
	if(ref$a eq 'ARRAY'){$b=$a}
	elsif(ref$a eq 'SCALAR'){$b=[$$a]}
	else{${$b}[0]=$a}

 #   
	unless($dan->{crc_table}){for($i=0;$i<256;$i++)
	{
			$crc=$i;
			for($j=8;$j>0;$j--){if($crc & 1){$crc=($crc>>1)^0xEDB88320}else{$crc>>=1}}
			push@{$dan->{crc_table}},$crc;
	}}

 #   
	$crc=0xFFFFFFFF;
	for$i(@{$b}){for(split(//,$i)){$crc=_update_crc($crc,ord,$dan->{crc_table})}}
	return ~$crc;

	sub _update_crc{$_[0]=${$_[2]}[($_[0]^$_[1])&0xff]^($_[0]>>8)}
 }

sub _codec_qp
 {
	my$body=shift;
	my$mode=shift;

	if($mode)	# 
	{
		$$body =~ s/=([\da-fA-F]{2})/pack("C", hex($1))/ge;
	}
	else		# 
	{
		$$body =~ s/([^\w\d<>\(\)\[\]\{\}\.\,\;\:\'\"\/\?\\\-\*\&\^\$@#\!\| ])/sprintf("=%02X", ord($1))/ges;
	}
	return$$body;
 }


1;
__END__

=head1 

DAN - Data Associative Network,          .

  ,     .

 :

    new -    ,    
    BaseVersion -    
    Cache -  
    Compact -      
    CreateDate - /   
    DeleteLink -    
    DeleteProperty -      
    Description - /  
    Exists -     
    Export -       ,
              
    FindId -      
    GetLanguage -   
    GetObject -  ,    
    GetObjectId -   
    Import -     ,
             
    Influence - /  
    Kill -     
    Languages - /   
    LinkExists -        
    LinkValue -   
    ModelId - /  
    ModelName - /  
    ModifyDate - /    
    PropertyBody -   
    PropertyCounter - /    
    PropertyCounterAll -      
    PropertyId -     
    PropertyLink -    
    PropertyLinkProperty -    
    PropertyLinkSort -     
          
    PropertyLinkSortProperty -    
           
    PropertyLinks -   
    PropertyLinksProperty -    
           
    PropertyLinksStructure -    
    PropertyLinkValue -   
    PropertyList -     
    PropertyName -   
    PropertyNextId -     
        ( )
    PropertyNextName -     
        ( )
    PropertyPrevId -     
        ( )
    PropertyPrevName -     
        ( )
    Repair (to do) -         
    Role2Role -  ,   , 
         
    RoleAlias -   
    RoleCorr -   
    RoleName -   
    RoleRest -   
    Roles -   
    RoleType -   
    RoleTypeBack -    
    RoleVector -     
    SaveModel -   
    SaveObject -   
    SetLanguage -   
    SetLink -    
    SetProperty -     
    SetRole -    
    SetType -  
    SwapLang -       
    Switch2RO -      
    Switch2RW -        
    TypeAlias -   
    TypeId -   
    TypeList -     
    TypeListName -     
    TypeName -   
    TypeRest -    
    Types -   ,   
    VerifyProperty -  ,   

=head1 

  DAN     DB_File.
DAN    DB_File   (DB_BTREE). 
   DB_File (DB_HASH, DB_RECNO)   ,
       .

    use DAN;
    $dan=new DAN( $model, $base1, $base3 [,$mode] );

:

    use DAN;
    $dan=new DAN( $model, '/var/danindex.db', '/var/danbody.db', 1);

,     DAN:

    $dan=new DAN( $model, '/var/dan1.db', '/var/dan3.db', 1 );

        
  danindex.db ( )  danbody.db ( ).

I<      ,     .>

 $model -   .    danindex.db
(dan1.db)    ,    
  .    danbody.db (dan3.db)  
 ( ,    ).

   $mode,      . 
     -  
Switch2RO  Switch2RW.

      .


=head1 

 DAN      .

   ( ) -     
,       
(),  ,      ,
   ,    -  
   .    
  <F<mailto:mak@may.nnov.ru>>.

    .

	    . ,  
         
. ,   B<>   
B<>, B<>     
 B<>.

	      . 
   ,      
, ,  .

     ,   
B<>      
 B<>  B<>,
B<>   .   ,  
   -  (    ), 
  .     ,   
    ,    ,   . 
         
  , ,      , 
   ,   .

    -   ,   
      . 
    ,      
 - .

  ,     
  ,    . 
  .  ,     
   ,       
,       .

   ,     
 ,     .    
     " ", 
     -   .  
        ,
        .  
        .

        
 .     ,     
  -    ,  , 
   .

         
.         
 .

       DAN.pm  Perl 
     F<http://www.wtg.ru/download/dan.zip>.
    ,   
       .    
F<http://www.wtg.ru/cgi-bin/zsd4.cgi>.

  ,    
    ,     ,
  .      , 
       .

   DAN    
WTG Zebra (F<http://www.wtg.ru/zebra>).  DAN  
      -  
,     ,    
.

         
F<http://www.may.nnov.ru/mak/cgi-bin/x>.
          
    .     ,
   Perl (   Net),  
      .

=head1 

=over 10

=item new

    ,  ,
   .

    use DAN;
    use DB_File;
    ...
    $dan=new DAN( $model, $dan1, $dan2 [,$mode] );
    ...
    print $dan->Description;

$model -    , $dan1 -   ,
$dan3 -   , $mode -  ,  ,
    ,  -   . 
    ,        
    Switch2RW (    Switch2RO).

=item B<Cache>

       .  
,  ,   ,    
   . ,     
 .     
:

    $dan->Cache(1);

      (   ):

    $dan->Cache;

        .
           
, ,  ,    
 .   ,       ,
    .  , 
     ,  
        
 .

=item B<Compact>

         ,   
 .   .

    $number=$dan->Compact;

   ,     , 
     . 
    .

   .

      , 
        
.    , ,    
  ,     
    ,     .

=item B<CreateDate>

      .

    $date=$dan->CreateDate;

  ,     :

    $dan->CreateDate( time );

I<       SaveModel.>

=item B<DeleteLink>

   $role12   $idproperty1  $idproperty2,  
    $idproperty2   $idproperty1.

    $dan->DeleteLink( $idproperty1, $idproperty2, $role12 );

. : PropertyLink, PropertyLinks, SetLink.

=item B<DeleteObject>

     $idobject.

    $idtype=$dan->DeleteObject( $idobject );
    @deletedproperties=idtype=$dan->DeleteObject( $idobject );

      .    ,
      ,   .

     .     
,     .  
 ,    .

. : Exists, SaveObject, SetProperty.

=item B<DeleteProperty>

      $idproperty,      
 ,    .

    $dan->DeleteProperty( $idproperty );

. : SetProperty.

=item B<Description>

     .

    $date=$dan->Description;

  ,     :

    $dan->CreateDate( 'This is description of new DAN model.' );

I<       SaveModel.>

=item B<Exists>

    .    ,  ,
      .     ,   
   ,      
B<>    , ,   .
       B< >   
,     ().

    $idproperty=$dan->Exists( $idtype, $name, $body, $links );

   ,   . 
     .

. : DeleteObject, SaveObject, SetProperty.

=item B<Export>

         $file  
 .

    $number=$dan->Export( $file );

   .

     ,    ,
   ,     :

    $number=$dan->Export( $file, $begin_prop, $end_prop );

     ,   , 
     .

    $number=$dan->Export( $file, $begin_prop );

    ,   
,   ,     .  
  ,    .

    $number=$dan->Export( $file, $type_1, $type_2, ... );

 ,    ,   .
  .      ,
        Quoted-printable-.
     ,     (
 dan3)   Quoted-printable-.    
.       ,  
    .

. : Import.

=item B<FindId>

     ,   
   .

    $idproperty=$dan->FindId( $idtype, $name );

. : GetLanguage, Influence, Languages, SetLanguage, SwapLang.

=item B<GetLanguage>

    .

    $language=$dan->GetLanguage;

. : FindId, Influence, Languages, SetLanguage, SwapLang.

=item B<GetObject>

   .

    ( $name, $body, $properties )=$dan->GetObject( $idobject );

  .

$name -  .     
,        ,
        1.

$body -  () .

$properties -     , 
 :

    %{$properties}=(
        idrole1 => {
                        idproperty11 => property11,
                        idproperty12 => property12,
                        ...
                   }
        idrole2 => {
                        idproperty21 => property21,
                        idproperty22 => property22,
                        ...
                   }
        ...
    )

 idroleX -  , idpropertyXX -  
, propertyXX -   .

. : DeleteObject, Exists, GetObjectId, SaveObject.

=item B<GetObjectId>

  .

    $idobject=$dan->GetObjectId( $idtype, $name, \%links );

  .

$name -  .     
,        ,
        1.

$body -  () .

$properties -     ,    
 :

    %{$properties}=(
        vector1 => property1,
        vector2 => property2,
        ...
        vectorN => propertyN
    )

 vectorX - ,  ,   propertyX
     .   
     ,  , :

    Date.CreateDate.Article.Created

      , 
 .    ,     
,    .

 propertyX ,   ,   :

    vectorX => propertyX
    vectorX => [propertyX1, propertyX2, ... propertyXN]
    vectorX => \$idobjectX
    vectorX => [\$idobjectX1, \$idobjectX2, ... \$idobjectXN]
    vectorX => [
                    propertyX1, ... propertyXN,
                    \$idobjectX1, ... \$idobjectXN
               ]

    ,   
   ,      
.

  GetObject  GetObjectId    ,
       GetObject  
GetObjectId.    :

    ( $name, $body, $links )=$dan->GetObject( $idobject );
    for( keys %{$links} ){
        my @a;
        for( keys %{$links->{$i}} ){
            push @a,\$_
        }
        $links->{$i} = \@a;
    }
    $idobject = $dan->GetObjectId ( $idtype, $name, $links );

. : DeleteObject, Exists, GetObject, SaveObject.

=item B<Import>

         ,
    ,   .   ( )
,  .    
,    .  -  
     ,    .

    ($number_properties, $number_links)=$dan->Import( $file );

      
.

. : Export.

=item B<Influence>

     ,   
  .

    :

    @inf=$dan->Influence;

    :

    @oldinf=$dan->Influence( @newinf );

I<     
 .     
          
 .      ,
   , ""  
 .>

. : FindId, Languages, GetLanguage, SetLanguage, SwapLang.

I<       SaveModel.>

=item B<Kill>

  ,     .

    $dan->Kill;

I<        ( new)  
    .>

=item B<Languages>

      .

 :

    @languages=$dan->Languages();

     @languages   , 
 .

 :

    @oldlanguages=$dan->Languages( @newlanguages);

     @newlanguages    .
  .

DAN       
 RFC-1766 ( ISO 839-1).

      DAN    ,
   .    ,
   (   ).

   .    
. ,        , 
     .

I<       -
   ,   ,
 -   ,    -  
.  ,    , .   
 .>

. : FindId, Influence, GetLanguage, SetLanguage, SwapLang.

I<       SaveModel.>

=item B<LinkExists>

      .

    $link=$dan->LinkExists( $idproperty, $role );

      $role    ,
   .    .

. : DeleteLink, Exists, SetLink.

=item B<LinkValue>

    .

    $oldvalue=$dan->LinkValue( $idproperty1, $idproperty2, $role12, $value );

       ,      
 .       .  LinkValue
      .

   .

. : DeleteLink, PropertyLink, SetLink.

=item B<ModelId>

   .

    $idmodel=$dan->ModelId;

=item B<ModelName>

     .

    $name=$dan->ModelName;

  ,     :

    $name=$dan->ModelName( 'New name of DAN model.' );

I<       SaveModel.>

=item B<ModifyDate>

      .

    $time=$dan->ModifyDate;

   ,     :

    $time=$dan->ModifyDate( time );

I<       SaveModel.>

=item B<PropertyCounter>

       .

    $counter=$dan->PropertyCounter( $type );

  ,     :

    $counter=$dan->PropertyCounter( $type, $i );

        .

 $i    ,   .  
   ,    (  
  !).       
:        
,  ,    (   
$i    ,  -  ).
       PropertyCounterAll.

I<        
.>

. : PropertyCounterAll.

=item B<PropertyCounterAll>

      .

    $counter=$dan->PropertyCounterAll( $type );

        .
  ,     :

    $global_counter=$dan->PropertyCounterAll;

. : PropertyCounter.

=item B<PropertyBody>

     $idproperty.

    $body=$dan->PropertyBody( $idproperty );

      ,    $dan3
(.  new).        ()
 .       .  
,  .

        :

    $oldbody=$dan->PropertyBody( $idproperty, $newbody );

     .

. : GetLanguage, Influence, Languages, SetLanguage.

=item B<PropertyId>

       .

    $idproperty=$dan->PropertyId( $name );

. : PropertyBody, PropertyLink, PropertyLinkProperty, 
PropertyLinkSort, PropertyLinkSortProperty, PropertyLinks,
PropertyLinksProperty, PropertyLinksStructure, PropertyName.

=item B<PropertyLink>

     , 
    .

    $idlink=$dan->PropertyLink( $idproperty, $role );

      ,  
   .

. : PropertyBody, PropertyId, PropertyLinkProperty,
PropertyLinks, PropertyLinksProperty, PropertyLinksStructure, PropertyName.

=item B<PropertyLinkProperty>

     , 
    .

    $propertyname=$dan->PropertyLinkProperty( $idproperty, $role );

      ,  
    .

. : PropertyBody, PropertyId, PropertyLink, PropertyLinkSort,
PropertyLinkSortProperty, PropertyLinks, PropertyLinksProperty,
PropertyLinksStructure, PropertyName.

=item B<PropertyLinkSort>

     , 
    ,      
    .

    $idlink=$dan->PropertyLinkSort( $idproperty, $role );

 ,     ,    .

. : PropertyBody, PropertyId, PropertyLink, PropertyLinks,
PropertyLinkSortProperty, PropertyLinksProperty, PropertyLinksStructure,
PropertyName.

=item B<PropertyLinkSortProperty>

     , 
    ,      
    .

    $propertyname=$dan->PropertyLinkSortProperty( $idproperty, $role );

 ,     ,   
PropertyLinkProperty.

. : PropertyBody, PropertyId, PropertyLink, PropertyLinkSort,
PropertyLinks, PropertyLinksProperty, PropertyLinksStructure, PropertyName.

=item B<PropertyLinks>

       .

   $idproperty    :

    $roles=$dan->PropertyLinks( $idproperty );

    ,  .

     ,     
$role,     :

    $links=$dan->PropertyLinks( $idproperty, $role );

     .

      :

    my$roles=$dan->PropertyLinks( $idproperty );
    for $i ( @{$links} )
    {
        my$links=$dan->PropertyLinks( $idproperty, $i );
        for $j ( @{$links} )
        {
            print "Property linked $j \n"
        }
    }

. : PropertyBody, PropertyId, PropertyLink, PropertyLinkProperty,
PropertyLinkSort, PropertyLinkSortProperty, PropertyLinksProperty,
PropertyLinksStructure, PropertyName.

=item B<PropertyLinksProperty>

        .

    $links=$dan->PropertyLinksProperty( $idproperty, $role );

:

    $links=$dan->PropertyLinksProperty( $idproperty, $role );
    for $i ( keys %{$links} )
    {
        for $j ( keys %{$links->{$i}} )
        {
            print "Property linked $j, name $links->{$i}->{$j} \n"
        }
    }

. : PropertyBody, PropertyId, PropertyLink, PropertyLinkProperty,
PropertyLinkSort, PropertyLinkSortProperty, PropertyLinks,
PropertyLinksStructure, PropertyName.

=item B<PropertyLinksStructure>

       PropertyLinksProperty,
  ,      .

    $links=$dan->PropertyLinksStructure( $idproperty, $role );

. : PropertyBody, PropertyId, PropertyLink, PropertyLinkProperty,
PropertyLinkSort, PropertyLinkSortProperty, PropertyLinks,
PropertyLinksProperty, PropertyName.

=item B<PropertyLinkValue>

     PropertyLink  LinkValue.

    $linkvalue=$dan->PropertyLinksValue( $idproperty1, $role12 [, $newvalue] );

     :

    $idproperty2=$dan->PropertyLink( $idproperty1, $role12 );
    $linkvalue=$dan->LinkValue( $idproperty1, $idproperty2, $role12 [, $newvalue] );

  $newvalue,    .   
         .

. : LinkValue, PropertyLink.

=item B<PropertyList>

    ,    $type:

    $list=$dan->PropertyList( $type );

 :

    for $i ( @{$list} ) { print "Property $i \n" }

      .   :

    $list=$dan->PropertyList( $type, $mask, $number, $first )

 $mask - ,     , 
     ; $number -  ,
    ; $first - ,    
 .

. : TypeList, Types.

=item B<PropertyName>

   $idproperty.

    $name=$dan->PropertyName( $idproperty );

. : PropertyBody, PropertyId, PropertyLink, PropertyLinkProperty,
PropertyLinkSort, PropertyLinkSortProperty, PropertyLinks,
PropertyLinksProperty, PropertyLinksStructure.

=item B<PropertyNextId>

   ,   
.

    $idnextproperty=$dan->PropertyNextId( $idtype, $idcurrentproperty );

 $idtype -  , $idcurrentproperty - 
 .    ( 
) .    ,   .

. : PropertyNextName, PropertyPrevId, PropertyPrevName.

I<   ,    , 
 PropertyNextName.>

=item B<PropertyNextName>

   ,   
.

    $namenextproperty=$dan->PropertyNextName( $idtype, $namecurrentproperty );

 $idtype -  , $namecurrentproperty - 
 .    ( 
) .    ,   .

. : PropertyNextId, PropertyPrevId, PropertyPrevName.

I<   ,    ,
  PropertyNextId.>

=item B<PropertyPrevId>

   ,   
.

    $idprevproperty=$dan->PropertyPrevId( $idtype, $idcurrentproperty );

 $idtype -  , $idcurrentproperty - 
 .    ( 
) .    ,   .

. : PropertyNextId, PropertyNextName, PropertyPrevName.

I<   ,    , 
 PropertyPrevName.>

=item B<PropertyPrevName>

   ,   
.

    $nameprevproperty=$dan->PropertyPrevName( $idtype, $namecurrentproperty );

 $idtype -  , $namecurrentproperty - 
 .    ( 
) .      ,  
.

. : PropertyNextId, PropertyNextName, PropertyPrevId.

I<   ,    
  PropertyPrevId.>

=item B<Repair ( )>

       .

    $dan->Repair;

   ,   ,  
      ,  
.

=item B<Role2Role>

   $type1,   $role12  
  $type2,    $type3,   $role13
    $type2.

    $converted=$dan->Role2Role( $type1, $role12, $type3, $role13 [,$mode] );

   $mode  .  $mode  ,
      (   
 $type2 ).        
,  .

. : DeleteLink, SetLink.

=item B<RoleAlias>

   $role.

    $alias=$dan->RoleAlias( $role );

. : RoleCorr, RoleName, RoleRest, Roles, RoleType, RoleTypeBack,
RoleVector.

=item B<RoleCorr>

     $role12.

    $role21=$dan->RoleCorr( $role12 );

. : RoleAlias, RoleName, RoleRest, Roles, RoleType, RoleTypeBack,
RoleVector.

=item B<RoleName>

   $role.

    $name=$dan->RoleName( $role );

. : RoleAlias, RoleCorr, RoleRest, Roles, RoleType, RoleTypeBack,
RoleVector.

=item B<RoleRest>

   $role.

    $rest=$dan->RoleRest( $role );

  :

    0 -    ,   
               ,  ;
    1 -  ,  ,  ;
    2 -   .

  , ,  ,    
    ,       
 ,     .   ,   
    ,     
 .

. : RoleAlias, RoleCorr, RoleName, Roles, RoleType, RoleTypeBack,
RoleVector.

=item B<Roles>

  ,     .

    @roles=$dan->Roles;

. : RoleAlias, RoleCorr, RoleName, RoleRest, RoleType, RoleTypeBack,
RoleVector.

=item B<RoleType>

 ,   $role.

    $type=$dan->RoleType( $role );

. : RoleAlias, RoleCorr, RoleName, RoleRest, Roles, RoleTypeBack,
RoleVector.

=item B<RoleTypeBack>

 ,      $role ( ).

    $type=$dan->RoleTypeBack( $role );

. : RoleAlias, RoleCorr, RoleName, RoleRest, Roles, RoleType,
RoleVector.

=item B<RoleVector>

  ,     , 
      .

    $role=$dan->RoleVector( $vector );

:

    $role=$dan->RoleVector( 'Text.Biography.User.Author' );

:

    $idtype1 = 'Text';
    $role12 = 'Biography';
    $idtype2 = 'User';
    $role21 = 'Author';
    $vector = join( '.', $idtype1, $role12, $idtype2, $role21 );
    $role = $dan->RoleVector( $vector );

. : RoleAlias, RoleCorr, RoleName, RoleRest, Roles, RoleType,
RoleTypeBack.

=item B<SaveModel>

  .

    $dan->SaveModel;

  ,      .  ,
      ( SetRole  SetType)   
        .
 ,    ,    , 
       , 
  .       
SaveModel.

I<        ,   
   ,   ,    
.>

=item B<SaveObject>

     :

    $idobject=$dan->SaveObject( $id, $name, $body, \%properties )

   .

$id -    ,     .
    ,     ,
  ,    ,  
 .    ,     
       . 
   
,        .

$name -  .

$body -           .
  ,   ,    .

\%properties -      , 
,     GetObjectId.  
       .
    (, ,     
 ),  .    I<> 
    ,    
   .

I<       ,
  (body),         
  .     
   , ,   .>

. : DeleteObject, Exists, GetObject.

=item B<SetLanguage>

  .

    $oldlanguage=$dan->SetLanguage( $newlanguage )

  ,     
       .

. : FindId, Influence, Languages, GetLanguage, SwapLang.

=item B<SetLink>

   $idproperty1  $idproperty2 , 
 $role12.      
$idproperty2  $idproperty1.

    $oldproperty=$dan->SetLink( $idproperty1, $idproperty2, $role12 );

    ,    .
    3:

    -  ,
    -     ,     ,
    -   ,     .

   ( ),     
    .

. : DeleteLink, LinkExists.

=item B<SetProperty>

      .

    $idproperty=$dan->SetProperty( $arg1, $name, $body, $links );

 $name -  , $body -  ,  $links -   
   ( ,     
PropertyLinksStructure).

   $arg1     .

 $arg1   ,      
.   ,   .  , 
,    .

 $arg1    ,   
   ,       
   .

 $arg1      ,  , ,
 :

C<3:0>

        
 ,    .  
,       .

     .

. : DeleteProperty, Exists.

=item B<SetRole>

   $type1  $type2  $rolename12.

    $role12=$dan->SetRole( $type1, $type2, $role12 );

   $rolename12    .  
 ,  .      .

I<       SaveModel.>

=item B<SetType>

  $typename.

    $type=$dan->SetType( $typename );

   $typename    . 
  ,  .    
 .

I<       SaveModel.>

=item B<Switch2RO>

      (read-only).      
 ,      - .

    $dan->Switch2RO;

        ,  
    ,      
    .

. : Switch2RW.

I<         , 
     DAN (  ).
   (       )
 .>

=item B<SwapLang>

  ,  ,   .

    $dest_name=$dan->SwapLang( $idtype, $src_name, $dest_lang [, $src_lang] );

$src_name -  ,     
  . $dest_lang - ,     .
$src_lang - ,      (-
-    DAN).

. : FindId, GetLanguage, Influence, Languages, SetLanguage.

=item B<Switch2RW>

       .

    $dan->Switch2RO;

         .  
    ,    Switch2RO.  
       Switch2RW.

. : Switch2RO.

I<         , 
     DAN (  ).
   (       )
 .>

=item B<TypeAlias>

   $type.

    $alias=$dan->TypeAlias( $type );

=item B<TypeId>

   $typename.

    $type=$dan->TypeId( $typename );

=item B<TypeList>

     , 
  $type.

    $list=$dan->TypeList( $type );

:

    $list=$dan->TypeList( $type );
    for ( @{$list} ) { print "Property $_ \n" }

      Types.

=item B<TypeListName>

     , 
  $type.

    $list=$dan->TypeListName( $type );

:

    $list=$dan->TypeListName( $type );
    for ( @{$list} ) { print "Property $_ \n" }

      
  :

    $list=$dan->TypeListName( $type, $number, $first )

 $number -   ,  
 , $first - ,       .

=item B<TypeName>

   $type.

    $typename=$dan->TypeName( $type );

=item B<TypeRest>

   .

    $typerest=$dan->TypeRest( $type );

        
,     .   
  :

    0 -  ,    
            Exists, 
        ,  ,   -
          ,   
         ,    
             1;
    1 -         ,
          ()  ;
    2 -         ,
          ()  .

        :

    $typerest=$dan->TypeRest( $type, $newrest );

      .

I<       SaveModel.>

=item B<VerifyProperty>

 ,   .

    $res=$dan->VerifyProperty( $idproperty );

  $idproperty       , 
  .    1.    ,
 0.

=item B<Types>

  ,   .

    @list=$dan->Types;

:

    @list=$dan->Types;
    for ( @$list ) { print "Type $_ \n" }

=back

=head1 

 ,   B<DAN>.

=over 5

=item
    1.  . .,  . .,  . . I<
      WTG Zebra  
     .> / . 
-  "-
     ",
, , 2002. - . 77.

=item
    2. Mukhutdinova T.Z., Makarov Yu.B., Muhutdinov E.A. I<Program Package WTG
Zebra for Supporting Internet-based Open Education.> / Mat. of IEEE
International Conference on Advanced Learning Technologies (ICALT). 9-12
September 2002, Kazan, Tatarstan, Russia. - P. 185-187.

=back

=head1 

.  history.txt  .

=head1  

Copyright (c) XXI, White Tiger Group, Edward Muhutdinov.  
     . 
    ,  
       .
      
  ;  
         
,       
 .

=head1 

:   <F<mak@may.nnov.ru>>.

:   <F<wtiger@mail.ru>>.

=cut
