package Zebra;


sub BEGIN
 {
	use vars qw(@ISA $VERSION $COPYRIGHT $inx);
	$VERSION='0.20';
	$COPYRIGHT=$copyright=$Copyright=qq|&copy; XXI, <a href="http://www.wtg.ru/">WTG</a>|;
	$inx=\%::inx;
	return;
 }


sub codecqp
 {
	my$body=shift;
	my$mode=shift;

	if(ref$body eq 'ARRAY'){$b=$body}
	elsif(ref$body eq 'SCALAR'){$b=[$$body]}
	else{${$b}[0]=$body}
	$body=join('',@{$b});

	if($mode)	# 
	{
		$body =~ s/=([\da-fA-F]{2})/pack("C", hex($1))/ge;
	}
	else		# 
	{
		$body =~ s/([^\w\d<>\(\)\[\]\{\}\.\,\;\:\'\"\/\?\\\-\*\&\^\$@#\!\| ])/sprintf("=%02X", ord($1))/ges;
	}
	return$body;
 }


 ## CRC32 -   
 # $crc32=CRC32(text)  CRC32(\@text)
sub CRC32
 {
	my($a)=@_;my($crc,$i,$j,$b);
 #   
	if(ref$a eq 'ARRAY'){$b=$a}
	elsif(ref$a eq 'SCALAR'){$b=[$$a]}
	else{${$b}[0]=$a}

 #   
	unless($::inx{"\$__crc_table"}){for($i=0;$i<256;$i++)
	{
			$crc=$i;
			for($j=8;$j>0;$j--){if($crc & 1){$crc=($crc>>1)^0xEDB88320}else{$crc>>=1}}
			push@{$::inx{"\$__crc_table"}},$crc;
	}}

 #   
	$crc=0xFFFFFFFF;
	for$i(@{$b}){for(split(//,$i)){$crc=_update_crc($crc,ord,$::inx{"\$__crc_table"})}}
	return ~$crc;

	sub _update_crc{$_[0]=${$_[2]}[($_[0]^$_[1])&0xff]^($_[0]>>8)}
 }


 ## packtime -     
 # . : unpacktime, condencetime, stringdate, techdate
 # $code=packtime(@t)
sub packtime
 {	my$a=$_[0]+($_[1]+($_[2]+($_[3]+($_[4]-1+$_[5]*12)*32)*24)*60)*60;
	return$a;
 }



 ## unpacktime -     
 # @t=unpacktime($code,\@days,\@months)
 # code=XXXXXXXXXXX
 # sec|min|hour|day|month|fullyear|year|wday|wmonth
 # . : packtime, condencetime, techdate.
sub unpacktime
 {	unless($_[0]*1){return}
	my$s1=shift;unless($s1){return}
	my$days=shift;
	my$months=shift;
	my(@s);my$s=1;

	for(reverse map $s*=$_,1,60,60,24,32,12)
	{	unshift(@s,int($s1/$_));
		$s1-=$s[0]*$_;
	}
	$#s=5;$s1=$s[5];
	$s[6]=$s[5]-2000;++$s[4];
	for(@s[0..4,6]){$_=sprintf('%02d',$_)};

 #     ,   
	$s=$s[4];if($s>2){++$s}else{$s+=13;--$s1}
	$s=int(365.25*$s1)+int(30.6*$s)+$s[3]-621050;
	$s[9]=$s-int($s/7)*7+1;
	$s[7]=$days->[$s[9]];$s[8]=$months->[$s[4]];

	return@s;
 }


 ## techdate(@t) -      
sub techdate
 {	unless($_[3]){return '&#151;'}
	return(sprintf("%02d/%02d/%02d %02d:%02d:%02d",@_[3,4,6,2,1,0]))
 }


 ## condencetime -     
 # $code=condencetime($string,\@t)
 # string -       :
 #	- 24/02/2000
 #	- 24/02/2000 12:32
 #	- 24/02
 #	- 24
 #	- 12:44 24/02/2001
 #	- 23:11:49 27/01/2001
 #	- 12:44
sub condencetime
 {
	my$a=shift;
	my$b=shift;
	my@a=@{$b};
	my($t);
	
	if(($a*1)>60000000000){return$a}
 #  
	$a=~s/&nbsp;/ /g;
	if($a=~s/(\d+):(\d+)(?::(\d+))?//)
	{
		if($1){$a[2]=$1;++$t}
		if($2){$a[1]=$2;++$t}
		if($3){$a[0]=$3;++$t}
	}

 #  
	if($a=~s/(\d+)(?:[\\\/\.](\d+)(?:[\\\/\.](\d+))?)?//)
	{
		if($1){$a[3]=$1;unless($t){@a[0,1,2]=(0,0,0)}}
		if($2){$a[4]=$2}
		if($a[4]>12){@a[3,4]=@a[4,3]}
		if($3)
		{	$a[5]=$3;
			if($a[5]<50){$a[5]+=2000}
			elsif($a[5]>50&&$a[5]<1000){$a[5]+=1900}
		}
		else{my@t=localtime;$a[5]=$t[5]+1900}
	}
	return Zebra::packtime(@a)
 }




 ## correct -  
 #      ,  
 #           ,
 #    -      
 #  ,   - 
 #        / 
 #     - ,   
 #   .
 #    ,      
sub correct
 {	my($a,$mode)=@_;
	$a=~s/&#(\d*?);/chr($1)/eg;$a=lc$a;
	$a=~s/&(.*?);//g;
	$a=~tr//ABEKMHOPCTYXabeuonpcyxrBGDGIJLPFCXHXXYXEUAbgdgzjklmntfchxxyxeua/;
	unless($mode)
	{	$a=~tr/01/3Ol/;
	}
	$a=~s/\W//g;
	$a=lc$a;
	return$a
 }



 ## translate -  
 # $text=translate($text [,$mode])
 # mode=1 -  $  %  &#36;  &#37;
 # mode<0 -   
sub translate
 {	my$a=$_[0];
	if($_[1]>=0)
	{
		if($_[1]>1){map{s/\$/&#36;/go;s/%/&#37;/go;s/\x01/%01/go}$a}
		elsif($_[1]>2){map{s/\x01/%01/go}$a}
		else{map{s/\x0A/\n/;s/&/&amp;/go;s/"/&quot;/go;s/>/&gt;/go;s/</&lt;/go;if($_[1]){s/\$/&#36;/go;s/%/&#37;/go}}$a}
	}
	else
	{	map{s/&#(\d+);/chr($1)/ge;s/&amp;?/&/gi;s/&quot;?/"/gi;s/&lt;?/</gi;s/&gt;?/>/gi;s/&nbsp;?/ /gi}$a;
	}
	return$a;
 }


 ## condencearray -  
 # @rez=condencearray($mode,@array)
 # mode:	1 -   
 #		0 -    
sub condencearray
 {	my($mode,@a)=@_;
	my($i,$j,@b)=(0,0);
 A1:	for$i(0..$#a)
	{
		if($mode&&($a[$i]=~/^[\r\n]*$/)){next}
		for$j(($i+1)..$#a)
		{	if($a[$i] eq $a[$j]){next A1}
		}
		push@b,$a[$i];
	}
	return@b
 }


 ## addelement -    -
 # $newstring=addelement($oldstring,$element [,char])
sub addelement
 {	my$char;
	if($_[2]){$char=$_[2]}else{$char=chr(0)}
	return clear($_[0].$char.$_[1],$char);
 }

 ## deleteelement -    -
 # $newstring=deleteelement($oldstring,$element [,char])
sub deleteelement
 {	my$char;
	my$a=$_[0];if($_[2]){$char=$_[2]}else{$char=chr(0)}
	$a=~s/(^|$char)\Q$_[1]\E($|$char)/$char/;
	return clear($a,$char);
 }


 ## clear -     arg2
sub clear
 {	my($char,$i,$j);
	my$a=$_[0];if($_[1]){$char=$_[1]}else{$char=chr(0)}
	$a=join($char,condencearray(1,split(/\Q$char/,$a)));
	return$a;
 }



 ## zs_optselect -  
 # zs_optselect($name,$value,@values,@descs)
sub optselect
 {
	local@a=@_;
	local($a,$i,@b,$s);
	if($a[1]=~s/^\-//){$a=qq|<select class="select" name="$a[0]" disabled>|}
	else{$a=qq|<select class="select" name="$a[0]">|}
	for$i(2..($#a/2+1))
	{	$s=$a[$i+$#a/2];if(!$s){$s=$a[$i]}
		$a.=qq|<option value="$a[$i]"|.($a[1] eq $a[$i]?' selected':'').'>'.Zebra::translate($s,1)
	}
	return$a.'</select>';
 }


 ## unique_id -   
 # $id=unique_id($num)
 # num		-  
sub unique_id	#   
 {
	my($a)=@_;$a||=2;
	my($i,@b,$b,$c);

	my@a=split(//,localtime);
	for(@a){$c+=unpack('CC',$_)}

	for(1..$a)
	{
		$b=rand($$+localtime);
		$b=crypt($c,$b);
		$b=~s/\W//g;
		push@b,$b
	}
	return join('_',@b);
 }


sub ucfirst
 {

	my$text=shift;
	my$mode=shift;

	$text=~s|([a-z-A-Z-])|\x00|;
	my$b=$1;
	$b=~tr/a-z/A-Z/;
	$text=~s|\x00|$b|;
	return$text

 }

 ## makedir -  
 # $cnt=makedir(rights,dir1,dir2,dir3...)
 # rights - ,     
 # dirN - ,   
 # cnt -   
sub makedir
 {
	my$chmod=shift;
	my@dirs=@_;

	my($i,$cnt);

 A1:	for(@dirs)
	{
		s#\w:/#/#;
		my@a=split(/[\/\\]+/,$_);
		for$i(1..($#a))
		{
			my$a=join('/',@a[0..$i]);
			unless(-e$a)
			{
				unless(mkdir $a,$chmod){next A1}
			}
			unless(-d$a){next A1}
		}
		++$cnt
	}
	return$cnt
 }


sub _getv
 {
	my$name=shift;
	my$base=shift;
	my($value,$errorlevel,$added);


	if(exists$inx->{'$__wcache'}->{$base}->{$name})	#     
	{
		$value=$inx->{'$__wcache'}->{$base}->{$name};
		$errorlevel=3
	}
	elsif($inx->{'$__rcacheenabled'} && exists$inx->{'$__rcache'}->{$base}->{$name})	#     
	{
		$value=$inx->{'$__rcache'}->{$base}->{$name};
		$errorlevel=2
	}
	else	#    ,  ,      
	{
		$inx->{"\$__db_$base"}->get($name,$value);
		$errorlevel=1;
		if($inx->{'$__rcacheenabled'} && $inx->{'$__rcachemaxlength'}>length$value)
		{
			if((++$inx->{'$__rcachecount'})>$inx->{'$__rcachestring'}){delete$inx->{'$__rcachecount'};delete$inx->{'$__rcache'};$added=1;}
			$inx->{'$__rcache'}->{$base}->{$name}=$value;
		}
	}
	if($inx->{'$__zebradebug'})
	{
		my$a=${$inx->{'$__zebraiolog'}};
		print $a ('','','Rcache:','Wcache:')[$errorlevel]."$base - $name {${\(length$value)}}\n";
		if($added){print $a "RESET:read-cache\n" }
	}
	return$value
 }

sub _putv
 {
	my$name=shift;
	my$value=shift;
	my$base=shift;
	my($errorlevel,$added);
	my$b=${$inx->{'$__zebraiolog'}};

	$inx->{'$__wcache'}->{$base}->{$name}=$value;	#    
	my$a=length$value+length$name;
	if($inx->{'$__zebradebug'}){print $b "store:$base - $name {$a}\n"}

	if($inx->{'$__rcacheenabled'})
	{
		if((++$inx->{'$__rcachecount'})>$inx->{'$__rcachestring'}){delete$inx->{'$__rcachecount'};delete$inx->{'$__rcache'};if($inx->{'$__zebradebug'}){print $b "RESET:read-cache\n"}}
		$inx->{'$__rcache'}->{$base}->{$name}=$value;	#    
	}
	return 1;

 }



1;
__END__

=head1 

     WTG Zebra (<F<http://www.wtg.ru/zebra>>).

=head1 

       - 
        .

=head1 

     :

    use Zebra;

    , :

    $crc32 = Zebra::CRC32 ( $text );

=head1 

=over 10

=item addelement

    ,    ,  
     . 

    $newstring = addelement ( $oldstring, $element [, $separator] );

$separator - ,    .   ,  chr(0).

=item clear

      .

    $newstring = clear ( $oldstring [, $separator] );

$separator - ,    .   ,  chr(0).

=item condencearray

        .

    @newlist = condencearray ( $flag, @oldlist );

 $flag = 0,    .

=item condencetime

    ,    / .

    $code = condencetime ( $time );

$time     , :

    21.02.2002
    14:30
    14:30 21.02.2002
    14:30:25 21/02/2002
    14:30 21/02/02
    21/02/02 14:30
      

     ,    
, ,  unpacktime.

       - 
/,    ,   .

=item correct

      .

    $newstring = correct ( $oldstring );

=item CRC32

        32-
 .  :

    $crc32 = CRC32 ( $text );
    $crc32 = CRC32 ( \$text );
    $crc32 = CRC32 ( \@text );

=item deleteelement

     .

    $newstring = deleteelement ( $oldstring, $element [, $separator] );

$separator - ,    .   ,  chr(0).

=item packtime

         Zebra:

    $code = packtime ( @time );

  :

    0 - 
    1 - 
    2 - 
    3 - 
    4 - 
    5 -  (  )

=item techdate

  ,      
:

    DD/MM/YY HH:MM:SS

:

    $string = techdate ( @time );

=item translate

    HTML   , ,
<   &lt;, "  &quot;   .

    $newstring = translate ( $oldstring );

      :

    $newstring = translate ( $oldstring, -1 );

      1,   
  Zebra - $  %:

    $newstring = translate ( $oldstring, 1 );

=item unpacktime

      Zebra,    ,
 .

    @time = unpacktime ( $code, \@days, \@months );

 \@days  \@months -       .
 @time :

    0 - 
    1 - 
    2 - 
    3 - 
    4 - 
    5 -  (  )
    6 -  (  )
    7 -   ()
    8 -  

  \@days  \@months ,      .

=back

=head1 

Edward Muhutdinov <F<wtiger@mail.ru>>.   WTG Zebra (<F<http://www.wtg.ru/zebra>>).

WTG Zebra (C) XXI, White Tiger Group.

=head1 

12  2004.  0.20. ( .)

22  2003.  0.16. ( translate.)

12  2003.  0.15. ( .)

11  2002.  0.11. ( condencetime.)

13  2002.  0.10.

=cut
